<?php
/**
* @version		$Id: styleslist.php,v 1.4 2010/04/14 23:09:23 cvs Exp $
* @package		Joomla
* @subpackage	Components
* @copyright	Copyright (C) 2009 Antony Repin. All rights reserved.
* @author 		Antony Repin <jtmreseller@gmail.com>
* @license		GNU/GPL, see LICENSE
*/

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();

/**
 * Renders a list element
 *
 * @package 	Joomla.Framework
 * @subpackage		Parameter
 * @since		1.5
 */

class JElementStyleslist extends JElement
{
	var	$_name = 'Styleslist';
	var	$_parent = null;
	
	function __construct($parent = null) {
		$this->_parent = $parent;
	}
	
	function getName() {
		return $this->_name;
	}
	
	function render(&$xmlElement, $value, $control_name = 'params')
	{
		$name	= $xmlElement->attributes('name');
		$label	= $xmlElement->attributes('label');
		$descr	= $xmlElement->attributes('description');
		//make sure we have a valid label
		$label = $label ? $label : $name;
		$result[0] = $this->fetchTooltip($label, $descr, $xmlElement, $control_name, $name);
		$result[1] = $this->fetchElement($name, $value, $xmlElement, $control_name);
		$result[2] = $descr;
		$result[3] = $label;
		$result[4] = $value;
		$result[5] = $name;

		return $result;
	}
	
	function fetchTooltip($label, $description, &$xmlElement, $control_name='', $name='')
	{
		$output = '<label id="'.$control_name.$name.'-lbl" for="'.$control_name.$name.'"';
		if ($description) {
			$output .= ' class="hasTip" title="'.JText::_($label).'::'.JText::_($description).'">';
		} else {
			$output .= '>';
		}
		$output .= JText::_( $label ).'</label>';

		return $output;
	}

	function fetchElement($name, $value, &$node, $control_name)
	{
		$class = $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="inputbox"';
		
		$doc = &JFactory::getDocument();
		
		$styles_js = "window.addEvent('domready', function() {
			$('urlparamsstyle').addEvent('change', function(item){
				var length = this.length;
				var selected = this.value;
				var options = this.options;
				
				var link_textarea = $('element-box').getElement('input[name=link]');
				var link_text = $('element-box').getElement('input[name=link]').value;
				
				var link_arr=link_text.split('&');
				var trash = link_arr.pop();
				
				link_text = link_arr[0];
				link_text+= '&style='+selected;
				
				link_textarea.value=link_text;
				link_textarea.defaultValue=link_text;
				
				var hidden = $('element-box').getElements('input[type=hidden]');
				hidden.each(function(item){
					if (item.name=='link') {
						item.value = link_text;
						itemDefaultValue = link_text;
					}
				});
				
				//alert('');
				
			});
		});"; 
		
		$doc->addScriptdeclaration($styles_js);
		
		$class = ( $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="inputbox"' );
		
		require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jtm'.DS.'helpers'.DS.'helper.php' );
		$styles = JtmHelper::getStyles();
		
		foreach ($styles as $style) {
			$st_safe = JFilterOutput::stringURLSafe($style['title']);
			$options[] = JHTML::_('select.option', $st_safe, JText::_($style['title']));
		}
		array_unshift($options, JHTML::_('select.option', '', '- '.JText::_('Select Style').' -'));

		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']', $class, 'value', 'text', $value, $control_name.$name);
	}
}
