<?php
/**
 * @package    JTM Reseller
 * @subpackage Component
 * @(#) $Header: /home/cvs/custom_code/com_jtm/admin/controllers/cpanel.php,v 1.8 2010/02/12 17:05:04 takeshi Exp $
 * @license    GNU/GPL
 * @copyright (C) 2009-2010 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: cpanel.php,v 1.8 2010/02/12 17:05:04 takeshi Exp $
*/
class JtmHelper
{
	var $_data = null;
	
	
	
	//-----------------------------------------------------------------------
	/**
	 * Generate download URLs for package
	 *
	 * @param	string	$package
	 * @param	array	$udata
	 * @param	int		$start
	 * @param	int		$step
	 */
	//-----------------------------------------------------------------------
	//-----------------------------------------------------------------------
	function getPackageUrl($package=null, $userconf=null, $from=0, $to=30000) {
		
		$linebreak = '|';
    	$delim = ',';
    	$list_delim = ';';
    	$list_begin = '[[[';
    	$list_end = ']]]';
    	$currency = 'USD';
    	$this->_data['url'] = 'http://www.templatemonster.com';
    	
    	switch ($package) {
    		
    		case 'tscreenshots':
    			$this->_data['url'] .= "/webapi/templates_screenshots4.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			$this->_data['url'] .= "&list_delim=$list_delim";
    			$this->_data['url'] .= "&list_begin=$list_begin";
    			$this->_data['url'] .= "&list_end=$list_end";
    			$this->_data['url'] .= '&full_path=true';
    			$this->_data['url'] .= "&currency=$currency";
    			//$this->_data['url'] .= '&from='.$from.'&to='.$to;
    			
    			break;
    			
    		case 'tsources':
    			$this->_data['url'] .= "/webapi/template_sources.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			//$this->_data['url'] .= '&from='.$from.'&to='.$to;
    			break;
    		
    		case 'tkeywords':
    			$this->_data['url'] .= "/webapi/template_keywords.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			//$this->_data['url'] .= '&from='.$from.'&to='.$to;
    			break;
    			
    		case 'authors':
    			$this->_data['url'] .= "/webapi/authors.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			break;
    			
    		case 'categories':
    			$this->_data['url'] .= "/webapi/categories.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			
    			$lang =& JFactory::getLanguage();
    			$locale = $lang->getTag();
    			$locale = eregi_replace('-[A-Z]+$', '', $locale);
    			
    			$this->_data['url'] .= "&locale=$locale";
    			break;
    		
    		case 'styles':
    			$this->_data['url'] .= "/webapi/styles.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			break;
    			
    		case 'tcategories':
    			$this->_data['url'] .= "/webapi/template_categories.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			//$this->_data['url'] .= '&from='.$from.'&to='.$to;
    			break;
    			
    		case 'tstyles':
    			$this->_data['url'] .= "/webapi/template_styles.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			//$this->_data['url'] .= '&from='.$from.'&to='.$to;
    			break;
    			
    		case 'featured':
    			$this->_data['url'] .= "/webapi/featured.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			break;
    			
    		case 'ttypes':
    			$this->_data['url'] .= "/webapi/templates_types.php";
    			$this->_data['url'] .= "?linebreak=$linebreak";
    			$this->_data['url'] .= "&delim=$delim";
    			break;
    			
    		default:
    			return false;
    			break;
    	}

    	return $this->_data['url'];
    	
    	
    	
	}
	
	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	function aliases() {
		
		$this->_data = Array();
		
		
		$this->_data['tscreenshots']=Array();
		$this->_data['tscreenshots']['title']="Templates Screenshots";
		$this->_data['tscreenshots']['alias']="tscreenshots";
		$this->_data['tscreenshots']['uri']="/webapi/templates_screenshots4.php";

		$this->_data['tsources']= Array();
		$this->_data['tsources']['title']="Templates Sources";
		$this->_data['tsources']['alias']="tsources";
		$this->_data['tsources']['uri']="/webapi/template_sources.php";

		$this->_data['tkeywords']= Array();
		$this->_data['tkeywords']['title']="Templates Keywords";
		$this->_data['tkeywords']['alias']="tkeywords";
		$this->_data['tkeywords']['uri']="/webapi/template_keywords.php";
		
		$this->_data['authors']= Array();
		$this->_data['authors']['title']="Authors";
		$this->_data['authors']['alias']="authors";
		$this->_data['authors']['uri']="/webapi/authors.php";
		
		$this->_data['categories']= Array();
		$this->_data['categories']['title']="Categories";
		$this->_data['categories']['alias']="categories";
		$this->_data['categories']['uri']="/webapi/categories.php";
	
		$this->_data['styles']= Array();
		$this->_data['styles']['title']="Styles";
		$this->_data['styles']['alias']="styles";
		$this->_data['styles']['uri']="/webapi/styles.php";
	
		$this->_data['tcategories']= Array();
		$this->_data['tcategories']['title']="Templates Categories";
		$this->_data['tcategories']['alias']="tcategories";
		$this->_data['tcategories']['uri']="/webapi/template_categories.php";
	
		$this->_data['tstyles']= Array();
		$this->_data['tstyles']['title']="Templates Styles";
		$this->_data['tstyles']['alias']="tstyles";
		$this->_data['tstyles']['uri']="/webapi/templates_styles.php";
		
		$this->_data['ttypes']= Array();
		$this->_data['ttypes']['title']="Templates Types";
		$this->_data['ttypes']['alias']="ttypes";
		$this->_data['ttypes']['uri']="/webapi/templates_types.php";
		
		$this->_data['featured']= Array();
		$this->_data['featured']['title']="Featured Templates";
		$this->_data['featured']['alias']="featured";
		$this->_data['featured']['uri']="/webapi/featured.php";
		
		return $this->_data;
	}
	
	/**
	 * getCategories
	 *
	 * @return array
	 */
	function getCategories()
	{ 
		$db =& JFactory::getDBO();
		
		$query = "SELECT `catid`,`title` FROM `#__jtm_categories`  ORDER BY `title` ASC";
		
		$db->setQuery($query);
		
		return $db->loadAssocList();
		
	}
	
	/**
	 * getStyles
	 *
	 * @return array
	 */
	function getStyles()
	{ 

		$db =& JFactory::getDBO();
		$query = 
		"SELECT `styleid`, `title` FROM `#__jtm_styles` ORDER BY `title` ASC";
		
		$db->setQuery($query);
		
		return $db->loadAssocList();
	}
	
}