<?php
/**
 * @version		$Id: install.php,v 1.6 2010/04/14 02:41:26 cvs Exp $
 * @package		Joomla
 * @copyright	2003-2009 Think Network GmbH, Munich
 * @license		GNU General Public License
 * 
 * This is the special installer addon created by Andrew Eddie and the team of jXtended.
 * We thank for this cool idea of extending the installation process easily
 * copyright	2005-2008 New Life in IT Pty Ltd.  All rights reserved.
 */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.helper');

//$nPaths = $this->_paths;
$status = new JObject();
$status->modules = array();
$status->plugins = array();
$com_name = "JTM Reseller";
?>
<h2><?php echo JText::_("Welcome to Joomla Template Store!"); ?></h2>

<h3><?php echo JText::_('A complete turnkey solution to setup YOUR OWN custom template store within minutes!'); ?></h3>
<h4>Please check for recent version at our website: <a href="http://www.jtmreseller.com" target="_blank">http://www.jtmreseller.com</a></h4>
<p><?php echo JText::_('Click').' '.'<a style="color: #881111; font-weight: bold;" href="'.JRoute::_('index.php?option=com_jtm&task=regreseller&s=l').'">'.JText::_('Continue').'</a>'.' '.JText::_('to setup JTM Reseller Component') ?></p>
<?
/***********************************************************************************************
* ---------------------------------------------------------------------------------------------
* MODULE INSTALLATION SECTION
* ---------------------------------------------------------------------------------------------
***********************************************************************************************/

$modules = &$this->manifest->getElementByPath('modules');

if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module)
	{
		$mname		= $module->attributes('module');
		$mclient	= JApplicationHelper::getClientInfo($module->attributes('client'), true);

		// Set the installation path
		if (!empty ($mname)) {
			$this->parent->setPath('extension_root', $mclient->path.DS.'modules'.DS.$mname);
		} else {
			$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.JText::_('NO_MODULE_FILE'));
			return false;
		}

		/*
		* If the module directory already exists, then we will assume that the
		* module is already installed or another module is using that directory.
		*/
		if (file_exists($this->parent->getPath('extension_root'))&&!$this->parent->getOverwrite()) {
			$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.JText::_('MODULE_ALREADY_USING_DIR').': "'.$this->parent->getPath('extension_root').'"');
			return false;
		}

		// If the module directory does not exist, lets create it
		$created = false;
		if (!file_exists($this->parent->getPath('extension_root'))) {
			if (!$created = JFolder::create($this->parent->getPath('extension_root'))) {
				$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.JText::_('FAILED_CREATE_DIR').': "'.$this->parent->getPath('extension_root').'"');
				return false;
			}
		}

		/*
		* Since we created the module directory and will want to remove it if
		* we have to roll back the installation, lets add it to the
		* installation step stack
		*/
		if ($created) {
			$this->parent->pushStep(array ('type' => 'folder', 'path' => $this->parent->getPath('extension_root')));
		}

		// Copy all necessary files
		$element = &$module->getElementByPath('files');
		if ($this->parent->parseFiles($element, -1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy language files
		$element = &$module->getElementByPath('languages');
		if ($this->parent->parseLanguages($element, $mclient->id) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy media files
		$element = &$module->getElementByPath('media');
		if ($this->parent->parseMedia($element, $mclient->id) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		$mtitle		= $module->attributes('title');
		$mposition	= $module->attributes('position');
		$morder		= $module->attributes('order');

		if ($mtitle && $mposition) {
			// if module already installed do not create a new instance
			$db =& JFactory::getDBO();
			$query = 'SELECT `id` FROM `#__modules` WHERE module = '.$db->Quote( $mname);
			$db->setQuery($query);
			if (!$db->Query()) {
				// Install failed, roll back changes
				$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.$db->stderr(true));
				return false;
			}
			$id = $db->loadResult();

			if (!$id){
				$row = & JTable::getInstance('module');
				$row->title		= $mtitle;
				$row->ordering	= $morder;
				$row->position	= $mposition;
				$row->showtitle	= 0;
				$row->iscore	= 0;
				$row->access	= ($mclient->id) == 1 ? 2 : 0;
				$row->client_id	= $mclient->id;
				$row->module	= $mname;
				$row->published	= 1;
				$row->params	= '';

				if (!$row->store()) {
					// Install failed, roll back changes
					$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.$db->stderr(true));
					return false;
				}
				
				// Make visible evertywhere if site module
				if ($mclient->id==0){
					$query = 'REPLACE INTO `#__modules_menu` (moduleid,menuid) values ('.$db->Quote( $row->id).',0)';
					$db->setQuery($query);
					if (!$db->query()) {
						// Install failed, roll back changes
						$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.$db->stderr(true));
						return false;
					}
				}


			}


		}

		$status->modules[] = array('name'=>$mname,'client'=>$mclient->name);
	}
}

/***********************************************************************************************
* ---------------------------------------------------------------------------------------------
* PLUGIN INSTALLATION SECTION
* ---------------------------------------------------------------------------------------------
***********************************************************************************************/

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin)
	{
		$pname		= $plugin->attributes('plugin');
		$pgroup		= $plugin->attributes('group');
		$porder		= $plugin->attributes('order');

		// Set the installation path
		if (!empty($pname) && !empty($pgroup)) {
			$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.$pgroup);
		} else {
			$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('NO_PLUGIN_FILE'));
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// If the plugin directory does not exist, lets create it
		$created = false;
		if (!file_exists($this->parent->getPath('extension_root'))) {
			if (!$created = JFolder::create($this->parent->getPath('extension_root'))) {
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('FAILED_CREATE_DIR').': "'.$this->parent->getPath('extension_root').'"');
				return false;
			}
		}

		/*
		* If we created the plugin directory and will want to remove it if we
		* have to roll back the installation, lets add it to the installation
		* step stack
		*/
		if ($created) {
			$this->parent->pushStep(array ('type' => 'folder', 'path' => $this->parent->getPath('extension_root')));
		}

		// Copy all necessary files
		$element = &$plugin->getElementByPath('files');
		if ($this->parent->parseFiles($element, -1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy all necessary files
		$element = &$plugin->getElementByPath('languages');
		if ($this->parent->parseLanguages($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy media files
		$element = &$plugin->getElementByPath('media');
		if ($this->parent->parseMedia($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO();

		// Check to see if a plugin by the same name is already installed
		$query = 'SELECT `id`' .
		' FROM `#__plugins`' .
		' WHERE folder = '.$db->Quote($pgroup) .
		' AND element = '.$db->Quote($pname);
		$db->setQuery($query);
		if (!$db->Query()) {
			// Install failed, roll back changes
			$this->parent->abort(JText::_('PLUGIN').' '.JText::_('INSTALL').': '.$db->stderr(true));
			return false;
		}
		$id = $db->loadResult();

		// Was there a plugin already installed with the same name?
		if ($id) {

			if (!$this->parent->getOverwrite())
			{
				// Install failed, roll back changes
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('Plugin').' "'.$pname.'" '.JText::_('ALREADY_EXISTS').'!');
				return false;
			}

		} else {
			$row =& JTable::getInstance('plugin');
			$row->name = JText::_(ucfirst($pgroup)).' - '.JText::_(ucfirst($pname));
			$row->ordering = $porder;
			$row->folder = $pgroup;
			$row->iscore = 0;
			$row->access = 0;
			$row->client_id = 0;
			$row->element = $pname;
			$row->published = 1;
			$row->params = '';

			if (!$row->store()) {
				// Install failed, roll back changes
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.$db->stderr(true));
				return false;
			}
		}

		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup);
	}
}

/***********************************************************************************************
* ---------------------------------------------------------------------------------------------
* SETUP DEFAULTS
* ---------------------------------------------------------------------------------------------
***********************************************************************************************/

$db = &JFactory::getDBO();
$query = 'SELECT `id`' .
' FROM `#__components`' .
' WHERE parent = 0 and name=' .$db->Quote($com_name).
' AND parent = 0';
$db->setQuery($query);
$componentID = $db->loadResult();


if(!is_null($componentID) && $componentID > 0) {
	$query = 'UPDATE #__components SET params = '
		. $db->Quote("pr_code=\n"
		. "limit=16\n"
		. "adult_on=0\n"
		. "search_results=16\n"
		. "display_last_added=1\n"
		. "display_most_popular=1\n"
		. "display_zero=1\n"
		. "display_premium=1\n")
		. 'WHERE id = ' . $componentID;
	$db->setQuery($query);
	
	if (!$db->Query()) {
		// Install failed, roll back changes
		$this->parent->abort(JText::_('PLUGIN').' '.JText::_('INSTALL').': '.$db->stderr(true));
		
		return false;
	}
}

/***********************************************************************************************
* ---------------------------------------------------------------------------------------------
* OUTPUT TO SCREEN
* ---------------------------------------------------------------------------------------------
***********************************************************************************************/
$rows = 0;

?>
<h2><?php echo JText::_("Component").' '.JText::_('Installation'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" style="text-align: left; font-weight: bold;"><?php echo JText::_("Extension"); ?></th>
			<th></th>
			<th width="30%" style="text-align: center; font-weight: bold;"><?php echo JText::_("Status"); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" style="text-align: left;"><?php echo JText::_("Component"); ?></td>
			<td></td>
			<td style="color: green; text-align: center;"><?php echo JText::_("Installed"); ?></td>
		</tr>
<?php 
if (count($status->modules)) { ?>
		
	<tr>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_("Module"); ?></th>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_("Client"); ?></th>
			<th style="text-align: center; font-weight: bold;"><?php echo JText::_("Status"); ?></th>
		</tr>
	<?php 
	foreach ($status->modules as $module) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name'] ?></td>
			<td class="key" style="text-align: left;"><?php echo ucfirst($module['client']) ?></td>
			<td style="color: green; text-align: center;"><?php echo JText::_('Installed') ?></td>
		</tr>
	<?php 
	}
}
if (count($status->plugins)) { ?>
	<tr>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_('Plugin') ?></th>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_('Group') ?></th>
			<th style="text-align: center; font-weight: bold;"><?php echo JText::_("Status"); ?></th>
		</tr>
	<?php 
	foreach ($status->plugins as $plugin) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key" style="text-align: left;"><?php echo ucfirst($plugin['group']); ?></td>
			<td style="color: green; text-align: center;"><?php echo JText::_('Installed'); ?></td>
		</tr>
	<?php }
} ?>
</tbody>
</table>

<p>Now you can earn money by reselling TemplateMonster template products through your Joomla website!</p>
<p>Reasons to join:</p>
<ul>
<li>Registration and participation are FREE!</li>
<li>Earn 20% commission (10-50$ per sale on average)</li>
<li>All products have great market value.</li>
<li>Sell templates under YOUR OWN BRAND!</li>
<li><a style="text-decoration: underline;" href="index.php?option=com_jtm&task=regreseller&s=">Register at TemplateMonster using JTM's Live Form.</a> Start earning money immediately!</li>
<li>If someone comes through your website and leaves TemplateMonster website without a purchase you will still earn your affiliate fee if this visitor buys products at a later date.</li>
<li>Track your earnings and visitor statistics in real time.</li>
<li>TemplateMonster takes care of everything billing, delivery, anti-fraud protection, and customer service.</li>
<li>Advanced visitor traffic statistics.</li>
<li>You may withdraw your commission earnings whenever your balance reaches $100.</li>
<li>MVC allows you easily alter any page layout structure</li>
<li>Larger instant template preview when roll-over on the template thumbnail</li>
<li>With this Joomla Component you can easily alter the meta title and meta description for any of store pages while managing menu items.</li>
<li>Now you have all the tools in one place that will help you to optimize the template shop for the search engines and make it really user friendly for your customers.</li>
</ul>
<p>JTM Reseller component uses TemplateMonster API and you will be able to choose whether to keep all the templates data including template screenshots on your server or show images from TemplateMonster server if you don't have enough space. This feature will be available in the very next release.</p>
<p>JTM Reseller component can be easily updated with the new look using Joomla powerful templating capabilities. You can order the development of the custom theme from us and a get a unique fully custom solution for selling templates on your existing website or on a separate domain.</p>