CREATE TABLE IF NOT EXISTS `#__jtm_udata` (
				`id` int(11) NOT NULL auto_increment,
				`username` varchar(255) NOT NULL,
				`apikey` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM  ROW_FORMAT=DYNAMIC CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_authors` (
				`id` int(10) NOT NULL auto_increment,
				`aid` int(10) NOT NULL,
				`nick` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='All authors'' IDs and nicknames' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_categories` (
				`id` int(10) NOT NULL auto_increment,
				`catid` int(6) NOT NULL,
				`title` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`),
				UNIQUE KEY `num` (`catid`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='Templates numbers and corresponding categories' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_featured` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(6) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM ROW_FORMAT=FIXED COMMENT='The id\'s of featured templates' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_packages` (
				`id` int(10) NOT NULL auto_increment,
				`package` varchar(255) NOT NULL,
				`alias` varchar(255) NOT NULL,
				`uri` varchar(255) NOT NULL,
				`table` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM  ROW_FORMAT=DYNAMIC CHARSET=utf8;

DROP TABLE IF EXISTS `#__jtm_packages`;
CREATE TABLE IF NOT EXISTS `#__jtm_packages` (
				`id` int(10) NOT NULL auto_increment,
				`package` varchar(255) NOT NULL,
				`alias` varchar(255) NOT NULL,
				`uri` varchar(255) NOT NULL,
				`table` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM  ROW_FORMAT=DYNAMIC CHARSET=utf8;

INSERT INTO `#__jtm_packages` (`id`, `package`, `alias`, `uri`, `table`) VALUES
(1, 'Templates Screenshots', 'templates_screenshots', '/webapi/templates_screenshots4.php', 'tscreenshots'),
(2, 'Templates Sources', 'templates_sources', '/webapi/template_sources.php', 'tsources'),
(3, 'Templates Keywords', 'templates_keywords', '/webapi/template_keywords.php', 'tkeywords'),
(4, 'Authors', 'authors', '/webapi/authors.php', 'authors'),
(5, 'Categories', 'categories', '/webapi/categories.php', 'categories'),
(6, 'Styles', 'styles', '/webapi/styles.php', 'styles'),
(7, 'Templates Categories', 'templates_categories', '/webapi/template_categories.php', 'tcategories'),
(8, 'Templates Styles', 'templates_styles', '/webapi/template_styles.php', 'tstyles'),
(9, 'Featured Templates', 'featured', '/webapi/featured.php', 'featured'),
(10, 'Templates Types', 'templates_types', '/webapi/templates_types.php', 'ttypes');
			
CREATE TABLE IF NOT EXISTS `#__jtm_styles` (
				`id` int(10) NOT NULL auto_increment,
				`styleid` int(6) NOT NULL,
				`title` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='All templates styles' CHARSET=utf8;
			
CREATE TABLE IF NOT EXISTS `#__jtm_tcategories` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(6) NOT NULL,
				`catid` int(6) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='All templates categories' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_tkeywords` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(6) NOT NULL,
				`keywords` text NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='Keywords associated with templates' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_tscreenshots` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(10) NOT NULL,
				`price` varchar(8) NOT NULL,
				`exclusive_price` varchar(8) NOT NULL,
				`addition_date` date NOT NULL,
				`downloads` int(10) NOT NULL,
				`is_hosting` int(1) NOT NULL,
				`is_flash` int(1) NOT NULL,
				`is_adult` int(1) NOT NULL,
				`is_unique_logo` int(1) NOT NULL,
				`is_non_unique_logo` int(1) NOT NULL,
				`is_unique_corporate` int(1) NOT NULL,
				`is_non_unique_corporate` int(11) NOT NULL,
				`author` int(11) NOT NULL,
				`is_full_template` int(11) NOT NULL,
				`pages_amt` int(11) NOT NULL,
				`screenshots` text NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='Properties of templates' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_tsources` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(10) NOT NULL,
				`sources` varchar(255) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='Sources available for templates' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_tstyles` (
				`id` int(10) NOT NULL auto_increment,
				`tid` int(6) NOT NULL,
				`styleid` int(6) NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Sources available for templates' CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__jtm_ttypes` (
				`id` int(10) NOT NULL auto_increment,
				`typeid` int(6) NOT NULL,
				`description` text NOT NULL,
				PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Table of templates types' CHARSET=utf8;