<?
/**
 * @package    JTM Reseller
 * @subpackage Component
 * components/com_jtm/controller.php
 * @license    GNU/GPL
 * @copyright (C) 2009-2010 Antony Repin
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: controller.php,v 1.21 2010/04/17 02:39:53 cvs Exp $
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
require_once( JPATH_ROOT.DS.'components'.DS.'com_jtm'.DS.'helpers'.DS.'helper.php' );

/**
 * Component Controller
 * @package Joomla
 * @subpackage Components
 */
class JtmController extends JController {
	
	
	var $_model	= null;
	var $_tid = 0;
	var $_tids = array();
	var $_view	= null;
	var $_currency_name = '';
	var $_currency_value = 1;
	var $_lang = null;
	var $_cache = null;
	var $_connect_timeout = 20; // time in seconds
	var $_params = null;
	var $_menu = null;
	var $_menuparams = null;
	var $_itemid = 0;
	var $_templates = array();
	
	/**
	 * Constructor
	 *
	 * @param array $default
	 */
	function __construct($default = array()) {
		
		global $mainframe;
		
		$default['default_task'] = '';
		parent::__construct( $default );
		
		
		// tasks map
		$this->registerTask( 'frontpage', 'frontPage' );
		$this->registerTask( 'search', 'templateSearch' );
		$this->registerTask( 'affiliate', 'affiliate' );
		$this->registerTask( 'styles', 'templateStyles' );
		$this->registerTask( 'categories', 'templateCats' );
		$this->registerTask( 'single', 'templateDetails' );
		$this->registerTask( 'faq', 'faq' );
		$this->registerTask( 'terms', 'termsOfUse' );
		$this->registerTask( 'error', 'error' );
		$this->registerTask( 'buy-template', 'buyTemplate' );
		$this->registerTask( 'freetemplates', 'freeTemplates');
		
		$this->_tid = JRequest::getInt('tid');	
		
		// Import some libraries
		jtimport('eg');
		$this->link = new EgLink();
		
		// Local settings
		$this->_model = &$this->getModel('Jtm');
		$this->_cache = & JFactory::getCache();
		$this->_lang = JFactory::getLanguage();
		
		$this->_params =& JSite::getParams('com_jtm');
		
		$this->_model->parameters=$this->_params;
		$curr_symbol = $this->_model->getCurrencySymbol();
		$currency = $this->_cache->call(array('JtmModelJtm', 'getCurrency'), $this->_connect_timeout, $curr_symbol);
    	$this->_currency_multiplier = $currency['multiplier'];
    	$this->_currency_name = $currency['name'];
    	$this->_currency_value = $currency['value'];
    	$this->_model->currency_multiplier = $this->_currency_multiplier;
    	$this->_model->currency_name = $this->_currency_name;
    	$this->_model->currency_value = $this->_currency_value;
		
    	// Parameters setup
		
		
		
		$menus =& JMenuSite::getInstance('site');
		
		if ($menus->getActive()>0) {
			$this->_menu = $menus->getActive();
		} else {
			$items = $menus->getItems('component', 'com_jtm');
			
			foreach ($items as $item)
			if (eregi('view=frontpage', $item->link))
			$this->_menu = $item;
		}
	
	}
	
	/**
	 * Attach View to Controller
	 *
	 * @param string $viewname
	 * @return JtmView object
	 */
	function _attachView($viewname=null, $type='html') {
		if (!$this->_view && !empty($viewname)) {
			$view = &$this->getView($viewname, $type, 'JtmView');
		} else {
			$view = &$this->getView('Jtm', 'html', 'JtmView');
		}
		return $view;
	}
	
	function _loadAuthors() {
		$result = $this->_model->getAuthorsList();
		return $result;
	}
	
	/**
	 * Load categories list
	 *
	 * @return array
	 * @access private
	 */
	function _loadCategories() {
		
		if ($this->_params->get('adult_on', 0)) {
			$result = $this->_model->getCategories(1);
			//$result = $this->_cache->call(array('JtmModelJtm', 'getCategories'), 1);
		} else {
			$result = $this->_model->getCategories(0);
			//$result = $this->_cache->call(array('JtmModelJtm', 'getCategories'), 0);
		}
		
		return $result;
	}
	
	/**
	 * Enter description here...
	 *
	 * @return array
	 * @access private
	 */
	function _loadStyles() {
		//$result = $this->_cache->call(array('JtmModelJtm', 'getStyles'));
		$result = $this->_model->getStyles();
		return $result;
	}
	
	function _loadTemplatesXML() {
		
		// Require helper
		require_once(JPATH_SITE.DS.'components'.DS.'com_jtm'.DS.'helpers'.DS.'helper.php');
		
		// Load templates XML (from either cache or remote server)
		$this->_model->curl_params = array();
		$this->_model->tids = $this->_templates;
		$this->_model->dis_cdata = true;
		$this->_model->connect_timeout = $this->_connect_timeout;
		$xml_result = $this->_model->multiRequestCache();
		$result = array();
		
		foreach ($xml_result as $data) {
			$children = $data->template;
			$template = JtmHelper::parseXMLData($children);
			$template = $template['template'];
			
			$this->_model->to_parse = $template['screenshots_list']['screenshot']['uri'];
			$template['screenshots_list']['screenshot']['uri'] = $this->_model->parseScreenshots();
			$template['keywords'] = explode(' ', $template['keywords']);
			
			$titles = $template['pages']['page']['name'];
			$screenshots_data = $template['pages']['page']['screenshots']['scr'];
			unset($screenshots_data['scr_type_id']);
			
			foreach ($titles as $key=>$title) :
			$pages[$key]['title']=$title;
			endforeach;
			
			$type = strtolower($template['template_type']['type_name'][0]);

			foreach ($screenshots_data['uri'] as $key=>$string){
					$regs = array();
					if (eregi('/[0-9]+(-drupal|-b|-is|-bcss|-wp-b|-ls|-joom-b|-m-b|-mambo-b|-osc-b)?-?([0-9]+)?\.jpg', $string, $regs)) {
						
						if (!empty($regs[3]))
						$reg = $regs[3];
						else $reg=0;
						
						$pages[$reg]['psd_homepage_type']=$screenshots_data['description'][$key];
						$pages[$reg]['psd_homepage_file']=$string;
						$pages[$reg]['psd_homepage_width']=intval($screenshots_data['width'][$key]);
						$pages[$reg]['psd_homepage_height']=intval($screenshots_data['height'][$key]);
						
					}
					
					if (eregi('/[0-9]+-([0-9]+)-sph\.jpg', $string, $regs)) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						$pages[$reg]['html_content_type']=$screenshots_data['description'][$key];
						$pages[$reg]['html_content_file']=$string;
						$pages[$reg]['html_content_width']=intval($screenshots_data['width'][$key]);
						$pages[$reg]['html_content_height']=intval($screenshots_data['height'][$key]);
						
					}
					
					if (eregi('/[0-9]+-([0-9])|osc|wp+-b\.jpg', $string, $regs)) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						$pages[$reg]['psd_content_type']=$screenshots_data['description'][$key];
						$pages[$reg]['psd_content_file']=$string;
						$pages[$reg]['psd_content_width']=intval($screenshots_data['width'][$key]);
						$pages[$reg]['psd_content_height']=intval($screenshots_data['height'][$key]);
					}
					
					if (eregi('/[0-9]+-?s?m?\.html', $string)  && (eregi('flash', $type) || eregi('swish', $type) || eregi('magento', $type))) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						if (!empty($screenshots_data['description'][$key])):
						$pages[$reg]['flash_preview_type']=$screenshots_data['description'][$key];
						else :
						$pages[$reg]['flash_preview_type']='FLASH PREVIEW';
						endif;
						
						$pages[$reg]['flash_preview_file']=$string;
						$pages[$reg]['flash_preview_width']=intval($screenshots_data['width'][$key]);
						$pages[$reg]['flash_preview_height']=intval($screenshots_data['height'][$key]);
					}
					
					
					
					if (eregi('/[0-9]+-rs\.jpg', $string, $regs)) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						$pages[$reg]['psd_rs_type']=$screenshots_data['description'][$key];
						$pages[$reg]['psd_rs_file']=$string;
						$pages[$reg]['psd_rs_width']=$screenshots_data['width'][$key];
						$pages[$reg]['psd_rs_height']=$screenshots_data['height'][$key];
					}
					
					
					if (eregi('/[0-9]+-(h|h-f1|joom-b-p|mambo-b-p|h-n|z-b)?\.jpg', $string)) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						$pages[$reg]['html_homepage_type']=$screenshots_data['description'][$key];
						$pages[$reg]['html_homepage_file']=$string;
						$pages[$reg]['html_homepage_width']=intval($screenshots_data['width'][$key]);
						$pages[$reg]['html_homepage_height']=intval($screenshots_data['height'][$key]);
					}
					
					if (empty($pages[0]['html_homepage'])) {
						$pages[0]['file']=$string;
						$pages[0]['width']=intval($screenshots_data['width'][$key]);
						$pages[0]['height']=intval($screenshots_data['height'][$key]);
					}
					
					if (eregi('/[0-9]+-(gallery|wp|wt|html|cre|drupal|php|joom|magento|mambo|php-n|z-html)?\.html', $string) && !eregi('flash', $type) && !eregi('swish', $type)) {
						
						if (!empty($regs[1]))
						$reg = $regs[1];
						else $reg=0;
						
						$pages['banner_file']=$string;
						$pages['banner_width']=430;
						$pages['banner_height']=60;
					}
			}
			
			
			$template['pages']=$pages;
			
			array_push($result, $template);
		}

		return  $result;
	}
	
	function _loadSearchFormLists() {
		
		$styles = $this->_loadStyles();
		$categories = $this->_loadCategories();
		$authors = $this->_loadAuthors();
    	
		// ---------------------------------------------------------------------------------------
    	// ---------------------------------------------------------------------------------------
    	// Styles list for search form
    	// ---------------------------------------------------------------------------------------
		$styleslist = array();
		$styles_jtext=array();
    	$styleslist[] = JHTML::_('select.option', 0, ucfirst(JText::_('LIST CHOOSE')).'...');
    	foreach ($styles as $st) {
    		$al = JtmHelper::genJTextAlias($st->title, 'style');
    		$style_tr =& JText::_($al);
    		$styles_jtext[$st->styleid] = $style_tr;
    	}
    	asort($styles_jtext);
    	foreach ($styles_jtext as $key=>$st) {
    		$styleslist[] = JHTML::_('select.option', $key, JText::_($st));
    	}
    	$styleslist = JHTML::_('select.genericlist', $styleslist, 'style', 'size="1" class="inputbox"', 'value', 'text', 0);
    	
    	// ---------------------------------------------------------------------------------------
    	// ---------------------------------------------------------------------------------------
    	// Categories list for search form
    	// ---------------------------------------------------------------------------------------
    	$catlist = array();
    	$cats_jtext=array();
    	$catlist[] = JHTML::_('select.option', 0, ucfirst(JText::_('LIST CHOOSE')).'...');
    	foreach ($categories as $cat) {
    		$al = JtmHelper::genJTextAlias($cat->title, 'category');
    		$cat_tr =& JText::_($al);
    		$cats_jtext[$cat->catid] = $cat_tr;
    	}
    	asort($cats_jtext);
    	foreach ($cats_jtext as $key=>$cat) {
    		$catlist[] = JHTML::_('select.option', $key, $cat);
    	}
    	$catlist = JHTML::_('select.genericlist', $catlist, 'category', 'size="1" class="inputbox"', 'value', 'text', 0);
    	
    	// ---------------------------------------------------------------------------------------
    	// ---------------------------------------------------------------------------------------
    	// Authors list for search form
    	// ---------------------------------------------------------------------------------------
    	$authorslist = array();
    	$authorslist[] = JHTML::_('select.option', 0, ucfirst(JText::_('LIST CHOOSE')).'...');
    	foreach ($authors as $author) {
    		$authorslist[]=JHTML::_('select.option',$author->aid, $author->nick);
    	}
    	$authorslist = JHTML::_('select.genericlist', $authorslist, 'author', 'size="1" class="inputbox"', 'value', 'text', 0);
    	$this->_view->assignRef('authorslist', $authorslist);
		
    	// rturn search lists
    	return array($styleslist, $catlist, $authorslist);
		
	}
	
	/*
	function _readJTMCookie($v=''){
		
		if (empty($v))
		return false;
		
		$r = array();
		$t = explode(':', $v);
		$tmp = explode('=', $t[0]);
		$exc = explode('=', $t[1]);
		$r[$tmp[1]]=$exc[1];
		
		return $r;
		
	}
	*/
	
	/**
	 * Affiliate subscription page
	 *
	 */
	function affiliate() {
		
		$this->_view = &$this->_attachView('affiliate');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		// Assign model properties
		$this->_model->params = $params;
		
		// Assign view properties
		$this->_view->assignRef('menu', $this->_menu);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assignRef('params', $this->_params);
		
		    	
		$this->_view->display();
	}
	
	function buyTemplate() {
		JRequest::setVar('tmpl', 'component');
		$this->_act = JRequest::getString('act', '');
		$this->_view = &$this->getView('single', 'raw', 'JtmView');
		
		switch ($this->_act) {
			
			case 'cart-remove-item':
				JRequest::checkToken('get') or die('Invalid Token');
				
				$did = JRequest::getInt('did');
				if (empty($did))
				JError::raiseError(500, 'ID удаляемого шаблона не передан контроллеру!');
				
				foreach ($_COOKIE as $key=>$value) {
					if (eregi('jtmcart:[0-9]+', $key)) {
						$v = $this->_readJTMCookie($value);
						$key = key($v);
						if ($key==$did) {
							setcookie('jtmcart:'.$did, '', time()-3600, '/');
						} else {							
							$remaining[]=$value;
						}
					}
				}
				
				
				if (empty($remaining)) :
				$msg = JText::_('TEMPLATE').' '.$did.' '.JText::_('WAS LAST IN CART');
				$this->setRedirect(JRoute::_('index.php?option=com_jtm&task=frontpage&view=frontpage'), $msg);
				else :
				$msg = JText::_('TEMPLATE').' '.$did.JText::_('WAS REMOVED FROM CART');
				$this->setRedirect('index.php?option=com_jtm&task=buy-template&tid='.$remaining[0].'&Itemid='.$this->_menu->id.'&lang='.$this->_lang_short, $msg);
				endif;
				
				break;
				
			case 'cart-empty':
				JRequest::checkToken('get') or die('Invalid Token');
				
				foreach ($_COOKIE as $key=>$value) {
					if ($key=='jtmcart:')
					setcookie('jtmcart:'.$did, '', time()-3600, '/');
					/*
					if (eregi('jtmcart:[0-9]+', $key)) {
						$tmp = explode(':', $value);
						$tmpl = explode('=', $tmp[0]);
						$tmpl = intval($tmpl[1]);
						setcookie('jtmcart:'.$tmpl, '', time()-3600, '/');
					}
					*/
				}
				
				$msg = JText::_('Ваша корзина очищена');
				$this->setRedirect(JRoute::_('index.php&task=frontpage&view=frontpage'), $msg);
				break;
				
			default:
				
				
				
				// Attach view
				//$this->_view = &$this->_attachView('single', 'raw');
				// Set view model
				$this->_view->setModel($this->_model);
				
				// Check whether template ID is present
				$tid = JRequest::getInt('tid');
				if (empty($tid))
				JError::raiseError(500, 'ID шаблона не передан контроллеру!');
				
				$tids = array();
				foreach ($_COOKIE as $key=>$value) {
					if (eregi('jtmcart:[0-9]+', $key))
					$tmp = explode(':', $value);
					$tmpl = explode('=', $tmp[0]);
					$exc = explode('=', $tmp[1]);
					$tids[]['id']=intval($tmpl[1]);
				}
				
				
				if (!empty($tid)) :				
				setcookie('jtmcart:'.$tid, 'tid='.$tid.':exc=0', time()+3600*24*728, '/');
				$tids[]['id']=$tid;
				endif;
				
				foreach ($tids as $key=>$v) {
					if ($v['id']>0)
					$tids_temp[] = $v['id'];
					
				}
				$tids_unique = array_unique($tids_temp);
				
				$tids = array();
				foreach ($tids_unique as $v) {
					$tids[]['id']=$v;
				}
				
				$this->_view->assignRef('task', $this->_task);
				$this->_view->assignRef('act', $this->_task);
				$this->_view->assignRef('itemid', $this->_menu->id);
				
				$this->_params = $this->_model->checkDefaultParams($this->_params);
				
				$this->_model->curl_params = array();
				$this->_model->tids = $tids;
				$this->_model->dis_cdata = true;
				$this->_model->connect_timeout = $this->_connect_timeout;
				$xml_result = $this->_model->multiRequestCache();
				
				require_once(JPATH_SITE.DS.'components'.DS.'com_jtm'.DS.'helpers'.DS.'helper.php');
				$templates = array();
				
				foreach ($xml_result as $data) {
					$children = $data->template;
					$template = JtmHelper::parseXMLData($children);
					$template = $template['template'];
					$this->_model->to_parse = $template['screenshots_list']['screenshot']['uri'];
					$template['screenshots_list']['screenshot']['uri'] = $this->_model->parseScreenshots();
					
					array_push($templates, $template);
				}
				
				$exc = JRequest::getVar('exc');
				$exc = explode(':', $exc);
				$this->_view->assignRef('exclusive', $exc);
					
				$this->_view->assignRef('templates', $templates);
				
				$this->_model->c_multi = $this->_currency_value;
				$this->_view->assignRef('c_multi', $this->_currency_value);
				$this->_view->assignRef('lang', $this->_lang);
				
				$this->_view->display();
				
				break;
		}
		
		
		
		
	}
	
	/**
	 * Enter description here...
	 *
	 */
	/*
	function buyWebsite(){
		$errors = base64_encode("К сожалению эта функция сейчас отключена.");
		$this->setRedirect(JRoute::_("&task=error&errors=$errors"));
	}
	*/
	
	function display() {
		parent::display();
	}
	
	/**
	 * FAQ method
	 *
	 */
	function faq() {

		// Attach view
		$this->_view = &$this->_attachView('faq');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		// Assign model properties
		$this->_model->params = $this->_params;
		
		// Assign view properties
		$this->_view->assignRef('params', $this->_params);
		$this->_view->assignRef('itemid', $this->_itemid);
		$this->_view->assignRef('lang', $this->_lang);
		
		    	
		$this->_view->display();
		
	}
	
	//------------------------------------------------------------------
	/**
	 * Prepare free sample templates page
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function freeTemplates() {
		// Attach view
		$this->_view = &$this->_attachView('freetemplates');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		$com = JComponentHelper::getComponent('com_jtm');
		$params = $view_params = new JParameter($com->params);
		
		$menuitemid = JRequest::getInt('Itemid', 2);
		if ($menuitemid) {
			$menu = JSite::getMenu();
		    $view_params = $menu->getParams($menuitemid);
		    $this->_params->merge($view_params);
		    $this->_view->assignRef('params', $this->_params->merge($view_params));
		}
		
		$this->_view->assignRef('task', $this->_task);
		$this->_model->params = $params;
		    	
		$this->_view->display();
	}
	
	//------------------------------------------------------------------
	/** 
	 * Prepare front page
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function frontPage() {
		
		// initialize view
		$this->_view = &$this->_attachView('frontpage');
		$this->_view->setModel($this->_model);
		
		// load search form lists
		$form_lists = $this->_loadSearchFormLists();
		$this->_model->_styleslist= $form_lists[0];
		$this->_model->_catslist= $form_lists[1];
		$this->_model->_authorslist= $form_lists[2];
		
		// load parameters and active menu
		$this->_view->assignRef('params', $this->_params);
		$this->_view->assignRef('menu', $this->_menu);
		$this->_view->assignRef('itemid', $this->_itemid);
    	
		// Read frontpage templates blocks data from database using frontpage menu link parameters
    	$prms = $this->_model->prms;
    	$per_row = $this->_params->get('templates_per_row', 4);
    	$this->_model->q_limit = $per_row;
    	$this->_view->assignRef('per_row', $per_row);
    	
    	// Check whether there are non-default categories enabled
    	$c = 0;
    	foreach ($prms as $alias=>$parameter) {
    		if ($this->_params->get($alias, 0)==1) {
    			$this->_model->param_cat = $parameter;
    			$this->_model->param_cat_alias = $alias;
    			$items_blocks[$c] = $this->_model->getFPBlock();
    			$c++;
    		}
    	}
    	
    	// Load default 4 if there were none found above
    	$c = 0;
    	if (empty($items_blocks)) {
	    	$prms = array_slice($prms, 0 , 4);
	    	foreach ($prms as $alias=>$parameter) :
	    	$this->_model->param_cat = $parameter;
	    	$this->_model->param_cat_alias = $alias;
	    	$items_blocks[$c] = $this->_model->getFPBlock();
	    	$c++;
	    	endforeach;
    	}
    	
    	$bl = array();
		$tids = array();
		$i=0;
		
		foreach ($items_blocks as $block) {
			foreach ($block as $key=>$item) {
				$tids[$i]['id']=$item['tid'];
				$i++;
			}
		}
		
		
		// Retrieve template info from XML
		$this->_templates = $tids;
		$templates = $this->_loadTemplatesXML();
		
		// Sort templates to frontpage blocks
		$blocks_amt = count($templates)/$this->_model->q_limit;
		$blocks = array();
		
		foreach ($this->_model->prms as $key=>$param) {
			foreach ($templates as $template_key=>$template) {
				if ($this->_params->get($key, '')) {
					if (count($blocks[$param])<4) {
						foreach ($template['categories']['category']['category_name'] as $ley=>$cat) {
							//
							$template['categories']['category']['category_name'][$ley]=str_replace('&', 'and', $template['categories']['category']['category_name'][$ley]);
							$template['categories']['category']['category_name'][$ley]=str_replace('/', ' or ', $template['categories']['category']['category_name'][$ley]);
						}
						$blocks[$param][]=$template;
						unset($templates[$template_key]);
					}
					
				}
			}
		}
		
		
		// Assign view references
		$this->_view->assign('currency_symbol', $this->_currency_name);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assign('tblocks', $blocks);
		$this->_view->assignRef('magnify_css', $this->_model->magnify_css);
		$this->_view->assign('c_multi', $this->_currency_value);
		
		
		$this->_view->display();
		
		
	}
	
	 /**
	 * Gets a configuration value.
	 *
	 * @access	public
	 * @param	string	The name of the value to get.
	 * @return	mixed	The user state.
	 * @example	application/japplication-getcfg.php Getting a configuration value
	 */
	function getCfg( $varname )
	{
		$config =& JFactory::getConfig();
		return $config->getValue('config.' . $varname);
	}
	
	//------------------------------------------------------------------
	/**
	 * Single template details method
	 *
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function templateDetails() {
		
		// Attach view
		$this->_view =& $this->_attachView('single');
		
		// Set view model
		$this->_view->setModel($this->_model);
		$this->_view->assignRef('model', $this->_model);
		
		//$this->_params = $this->_model->checkDefaultParams($this->_params);
		
		// Assign view parameters
		$this->_model->parameters = $this->_params;
		
		// Assign view parameters
		$this->_view->assignRef('params', $this->_params);
		$this->_view->assignRef('menu', $this->_menu);
    	
    	// Load template ID into array
    	// for standard processing
		$this->_tids[]['id'] = $this->_tid;
		
		// Request template XML info
		$this->_model->curl_params = array();
		$this->_model->tids = $this->_tids;
		$this->_model->dis_cdata = true;
		$this->_model->connect_timeout = $this->_connect_timeout;
		$this->_templates = $this->_tids;
		$templates = $this->_loadTemplatesXML();
		
		$template = $templates[0];
		$this->_view->assignRef('template', $template);
		
		$layout = JtmHelper::stringURLSafe($template['template_type']['type_name']);
		$this->_view->assignRef('layout', $layout);
		$this->_model->layout = $layout;
		
    	//$this->_model->styles = $this->_loadStyles();
    	//$this->_model->cats = $this->_cache->call(array('JtmModelJtm', 'getCategories'));
    	$this->_view->assignRef('styles',$this->_loadStyles());
    	$this->_view->assignRef('cats', $this->_loadCategories());
    	
    	if (JRequest::getInt('template_page', null)>0)
    	$this->_view->assign('t_page', JRequest::getInt('template_page'));
    	
    	//$this->_view->assignRef('c_multi', $this->_currency_value);
		$this->_view->assign('currency_symbol', $this->_currency_name);
		$this->_view->assignRef('lang', $this->_lang);

    	$this->_view->display();
	}
	
	//------------------------------------------------------------------
	/**
	 * Templates by category method
	 *
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function templateCats() {
		
		global $mainframe;
		
		// Get category title from request
    	$category_get = JRequest::getString('category', '');
    	// for native Joomla SEF compatibility
    	$category_get = str_replace(':', '-', $category_get);
    	if (empty($category_get)) :
    	JError::raiseError(500, JText::_("ERROR CATEGORY NOT FOUND"));
		endif;
		
		
		
		// Attach view
		$this->_view =& $this->_attachView('categories');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		// Load search form lists
		$form_lists = $this->_loadSearchFormLists();
		$this->_model->_styleslist= $form_lists[0];
		$this->_model->_catslist= $form_lists[1];
		$this->_model->_authorslist= $form_lists[2];
    	
		// Assign model variables
		$this->_model->itemid = $this->_itemid;
		
		// Assign view variables
		$this->_view->assignRef('menu', $this->_menu);
		$this->_view->assignRef('params', $this->_params);
		$this->_view->assignRef('itemid', $this->_menu->id);
		$this->_view->assignRef('menu', $this->_menu);
    	
    	// Search for category in database
    	if (eregi('recent', strtolower($category_get))==true) :
    	$category_get = 'Zero-Downloads';
    	endif;
    	
    	$categories = $this->_loadCategories();
    	foreach ($categories as $c) {

    		$al = JFilterOutput::stringURLSafe($c->title);
    		
    		if ($al == $category_get) {
    			$category = $c->title;
    		}
    	}
    	//$category = str_ireplace('templates', '', $category);
    	
    	$this->_view->assignRef('category', $category);
    	$this->_model->template_category = $category;

    	// Load template ID's using category title
    	$this->_model->category = $category;
    	$catlist = $this->_model->getByCategory();
    	
    	foreach ($catlist as $key=>$c) {
			if (empty($c['tid'])) {
				unset($catlist[$key]);
			} else {
				$catlist[$key] = $c['tid'];
			}	
    	}
    	$tids = $catlist;
    	
    	//Setup pagination
    	$this->_model->templates = $tids; // for pagination to work
    	$limit = $this->_model->getLimit();
    	$limitstart = JRequest::getVar('limitstart', 0, 'get', 'int');
    	$this->_model->setState('limitstart', $limitstart);
    	$tids = array_slice($tids, $limitstart, $limit);
		
    	// Prepare ids array for processing
		foreach ($tids as $key=>$value):
		$t = $value;
		unset($tids[$key]);
		$tids[$key]['id']=$t;
		endforeach;
		
		// Retrieve template info from cached or remote XML
		$this->_templates = $tids;
		$templates = $this->_loadTemplatesXML();
		
		$this->_view->assignRef('tlist', $templates);
    	$this->_view->assignRef('currency_symbol', $this->_currency_name);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assignRef('magnify_css', $this->_model->magnify_css);
		
		$this->_view->display();
	}
	
	//------------------------------------------------------------------
	/**
	 * Search method
	 *
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function templateSearch() {
		
		// Attach view
		$this->_view = &$this->_attachView('Search');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		// Load search form lists
		$form_lists = $this->_loadSearchFormLists();
		$this->_model->_styleslist= $form_lists[0];
		$this->_model->_catslist= $form_lists[1];
		$this->_model->_authorslist= $form_lists[2];
		
		// Assign model properties
		$this->_model->itemid = $this->_menu->id;
		
		// Assign view properties
		$this->_view->assignRef('menu', $this->_menu);
		$this->_view->assignRef('params', $this->_params);
		
		// Process search request
    	$style = JRequest::getInt('style', '');
    	$keyword = JRequest::getString('keyword', '');
    	$author = JRequest::getInt('author', '');
    	$category = JRequest::getInt('category', '');
    	//$price_from = JRequest::getInt('price_from', '');
    	//$price_to = JRequest::getInt('price_to', '');
    	
    	$terms=array();
    	
    	$templates_by_style = array();
    	$templates_by_cat = array();
    	$templates_by_author = array();
    	$templates_by_keyword = array();
    	//$templates_by_price = array();
    	
    	// Get templates from search by style
    	if (!empty($style)) {
	    	$this->_model->styleid = $style;
	    	$stylename = $this->_model->getStyleName();
	    	$this->_model->style = $stylename;
	    	//$templates_by_style = $this->_cache->call(array('JtmModelJtm', 'getByStyle'), $stylename);
	    	$templates_by_style = $this->_model->getByStyle($stylename);
	    	$al = JText::_(JtmHelper::genJTextAlias($stylename, "style"));
	    	array_push($terms, JText::_('STYLE').':&nbsp;'.$al);
	    	
    	}
    	for ($i=0,$n=count($templates_by_style);$i<$n;$i++) :
    	unset($templates_by_style[$i]['styleid']);
    	endfor;
    	
    	// Get templates from search by category
    	if ($category) {
    		$this->_model->catid = $category;
    		$category = $this->_model->getCatName();
    		
    		$this->_model->template_category = $category;
    		$templates_by_cat = $this->_model->getByCategory();
    		
    		$al = JText::_(JtmHelper::genJTextAlias($category, "category"));
    		array_push($terms, JText::_('CATEGORY').':&nbsp;'.$al);
    		
    	}
    	
    	for ($i=0,$n=count($templates_by_cat);$i<$n;$i++) :
    	unset($templates_by_cat[$i]['catid']);
    	endfor;
    	
    	
    	// Get templates from search by author
    	if (!empty($author)) {
	    	$this->_model->authorid = $author;
	    	$this->_model->author = $this->_model->getAuthorName();
	    	$this->_view->assignRef('author', $this->_model->author);
	    	$templates_by_author = $this->_model->getByAuthor();
	    	array_push($terms, 'Author: '.$this->_model->author);
    	}
    	for ($i=0,$n=count($templates_by_author);$i<$n;$i++) :
    	$templates_by_author[$i]=$templates_by_author[$i]->tid;
    	endfor;    	
    	
    	// Get templates from search keyword
    	if (!empty($keyword)) {
    		$this->_model->keyword = $keyword;
	    	$templates_by_keyword = $this->_model->getByKeyword();
	    	//
	    	$al = JText::_(JtmHelper::genJTextAlias($keyword, 'keyword'));
	    	array_push($terms, JText::_('KEYWORD').':&nbsp;'.', '. $al);
    	}  
    	
    	// Get templates from search by price
    	/*
    	if (!empty($price_from) && !empty($price_to)) {
    		$this->_model->price_from = $price_from;
    		$this->_model->price_to = $price_to;
    		$templates_by_price = $this->_model->getPriceDelta();
    		array_push($terms, 'Price: from '.$this->_model->price_from.' to '.$this->_model->price_to);
    	} elseif (!empty($price_from) && empty($price_to)) {
    		$this->_model->price_from = $price_from;
    		$templates_by_price = $this->_model->getPriceFloor();
    		array_push($terms, 'Price: from '.$this->_model->price_from);
    	} elseif (empty($price_from) && !empty($price_to)) {
    		$this->_model->price_to = $price_to;
    		$templates_by_price = $this->_model->getPriceCeil();
    		array_push($terms, 'Price: below '.$this->_model->price_to);
    	}
    	*/
    	
    	//
    	
    	
    	$merge = array_merge($templates_by_style, $templates_by_keyword, $templates_by_author, $templates_by_cat);
    	
    	$this->_view->assignRef('terms', $terms);
    	
    	for ($i=0,$n=count($merge);$i<$n;$i++) {
    		if (is_array($merge[$i])) {
	    		if ($merge[$i]['tid']) {
	    			$mi = strlen($merge[$i]['tid']);
	    			if ($mi>1) {
	    				$merge[$i] = $merge[$i]['tid'];
	    			}
	    			
	    		}
    		}
    		
    		if ($merge[$i]->tid) {
    			$merge[$i] = $merge[$i]->tid;	
    		} 
    		
    		if (is_array($merge[$i]) && !$merge[$i]['tid']) {
    			$merge[$i] = $merge[$i];
    		} 
    		    		
    	}
    	$tids = array_unique($merge);
    	
    	//Setup pagination
    	$this->_model->templates = $tids; // for pagination to work
    	$limit = $this->_model->getLimitSearch();
    	$limitstart = $this->_model->getLimitstart();
    	$tids = array_slice($tids, $limitstart, $limit);
    	
    	// Prepare ids array for processing
		foreach ($tids as $key=>$value):
		$t = $value;
		unset($tids[$key]);
		$tids[$key]['id']=$t;
		endforeach;
		
		// Retrieve template info from cached or remote XML
		$this->_templates = $tids;
		
		
		
		$templates = $this->_loadTemplatesXML();
		$this->_view->assignRef('tlist', $templates);
    	
    	$this->_view->assignRef('currency_symbol', $this->_currency_name);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assignRef('magnify_css', $this->_model->magnify_css);
    	
	    $this->_view->display();
    	
	}
	
	//------------------------------------------------------------------
	/**
	 * Templates by style method
	 *
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function templateStyles() {
		
		global $mainframe;
		
		$style_get = JRequest::getString('style', '');
		$style_get = str_replace(':', '-', $style_get);
		
		if (empty($style_get)) {
    		JError::raiseError(500, JText::_('NO STYLE PROVIDED').'!');
    	} 
    	
    	$this->_view = &$this->_attachView('styles');
		
		// Set view model
		$this->_view->setModel($this->_model);
		
		// Load search form lists
		$form_lists = $this->_loadSearchFormLists();
		$this->_model->_styleslist= $form_lists[0];
		$this->_model->_catslist= $form_lists[1];
		$this->_model->_authorslist= $form_lists[2];
		
		// Check and apply parameters
		$params =& $mainframe->getPageParameters('com_jtm');
		
		$this->_model->itemid = $this->_itemid;
		
		$this->_view->assignRef('menu', $this->_menu);
		$this->_view->assignRef('params', $this->_params);
    	
    	// Search for style in database
    	$styles = $this->_loadStyles();
    	foreach ($styles as $style) {
    		$al = JFilterOutput::stringURLSafe($style->title);
    		if ($al == $style_get) {
    			$style_tmp = $style->title;
    		}
    	}
    	$style = $style_tmp;
    	$this->_view->assignRef('style', $style);
    	
    	if (!$this->_cache->call(array('JtmModelJtm', 'getByStyle'), $style)) {
    		$bystyle = $this->_model->getByStyle($style);
    	}
    	$bystyle = $this->_cache->call(array('JtmModelJtm', 'getByStyle'), $style);
		
    	$tids = array();
		foreach ($bystyle as $template) { 
			array_push($tids, $template['tid']);
		}
		
		//Setup pagination
    	$this->_model->templates = $tids; // for pagination to work
    	
    	$limit = $this->_model->getLimit();
    	$limitstart = JRequest::getVar('limitstart', 0, 'get', 'int');
    	$page = JRequest::getInt('page', 1);
    	
    	if ($page>1) {
    		$limitstart = $page*$limit;
    		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
    	} else { 
	    	$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
    	}
    	
    	
    	$this->_model->setState('limitstart', $limitstart);
    	$tids = array_slice($tids, $limitstart, $limit);
		
		// Prepare ids array for processing
		foreach ($tids as $key=>$value):
		$t = $value;
		unset($tids[$key]);
		$tids[$key]['id']=$t;
		endforeach;
		
		// Retrieve template info from XML
		$this->_templates = $tids;
		$templates = $this->_loadTemplatesXML();
		$this->_view->assignRef('tlist', $templates);			
    	
    	$this->_view->assignRef('currency_symbol', $this->_currency_name);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assignRef('magnify_css', $this->_model->magnify_css);
    	
		$this->_view->display();
	}
	
	//------------------------------------------------------------------
	/**
	 * Terms of use page
	 *
	 */
	//------------------------------------------------------------------
	//------------------------------------------------------------------
	function termsOfUse() {
		
		$this->_view = &$this->_attachView('Terms');
		$this->_view->setModel($this->_model);

		$this->_view->assignRef('params', $this->_params);
		    	
		$this->_view->display();
		
	}
	
}