<?
/**
 * @package    Jtm Reseller
 * @subpackage Component
 * components/com_jtm/controller.php
 * @license    GNU/GPL
 * @copyright (C) 2009 Antony Repin
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: ajax.php,v 1.4 2010/02/14 08:57:47 takeshi Exp $
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Ajax Controller
 * @package Joomla
 * @subpackage Components
 */
class JtmControllerAjax extends JController 
{
	var $_model = null;
	var $_view = null;
	var $_lang = null;
	var $_controller_name = '';
	var $_act = '';
	var $_error_level = 100;
	var $_templates = null;
	var $_tids = array();
	
	function __construct($default = array()) {
		
		$default['default_task'] = '';
		parent::__construct( $default );
		
		$this->_controller_name = JRequest::getVar('c', '');
		$this->_act = JRequest::getVar('act', '');
		
		if (JRequest::getVar('task', '', 'post')):
		$this->_task = JRequest::getVar('task', '', 'post');
		else:
		$this->_task = JRequest::getVar('task', '', 'get');
		endif;
		
		$this->registerTask( 'sendpayrequest', 'sendPayRequest');
		$this->registerTask( 'moneyformat', 'moneyFormat');
		$this->registerTask( 'invoice', 'invoice');
		
		$this->_model = &$this->getModel('Jtm');
		$this->_lang = &JFactory::getLanguage();
		
	}
	
	/**
	 * Enter description here...
	 *
	 * @param string $viewname
	 * @return JtmView object
	 */
	function _attachView($viewname=null) {
		if (!$this->_view && !empty($viewname)) {
			$view = &$this->getView($viewname, 'raw', 'JtmView');
		} else {
			$view = &$this->getView('Jtm', 'raw', 'JtmView');
		}
		return $view;
	}
	
	function _loadTemplatesXML() {
		
		// Require helper
		require_once(JPATH_SITE.DS.'components'.DS.'com_jtm'.DS.'helpers'.DS.'helper.php');
		
		// Load templates XML (from either cache or remote server)
		$this->_model->curl_params = array();
		$this->_model->tids = $this->_templates;
		$this->_model->dis_cdata = true;
		$this->_model->connect_timeout = $this->_connect_timeout;
		$xml_result = $this->_model->multiRequestCache();
		
		$result = array();
		
		foreach ($xml_result as $data) {
			$children = $data->template;
			$template = JtmHelper::parseXMLData($children);
			$template = $template['template'];
			$this->_model->to_parse = $template['screenshots_list']['screenshot']['uri'];
			$template['screenshots_list']['screenshot']['uri'] = $this->_model->parseScreenshots();
			
			array_push($result, $template);
		}
		
		return  $result;
	}
	
	function _readJTMCookie($v=''){
		
		if (empty($v))
		return false;
		
		$r = array();
		$t = explode(':', $v);
		$tmp = explode('=', $t[0]);
		$exc = explode('=', $t[1]);
		$r[$tmp[1]]=$exc[1];
		
		return $r;
		
	}
	
	/**
	 * Method to display view
	 */
	function display()
    {
		parent::display();
	}
	
	function invoice() {
		
		JRequest::setVar('tmpl', 'component');
		
		$this->_view = &$this->_attachView('single');
		$this->_view->setModel($this->_model);
		
		$cart_total = &JRequest::getInt('price');
		$cart_curr = &JRequest::getString('curr');
		$items = &JRequest::getString('items');
		
		$items = base64_decode($items);
		
		$items = explode(':', $items);
		$empty = array_pop($items);
		
		foreach ($items as $key=>$item) {
			$tmp = explode(',', $item);
			if (!empty($tmp[0])):
			
			$items[$key]=array();
			$items[$key]['id']=$tmp[0];
			$items[$key]['price']=$tmp[1];
			$items[$key]['exc']=$tmp[2];
			endif;
		}
		
		$this->_model->invoice_total = $cart_total;
		$this->_model->data = $items;
		$this->_model->invoice_currency = $cart_curr;
		$invoice_data = $this->_model->getInvoiceData();
		$this->_view->assignRef('invoice_data', $invoice_data);
		$this->_view->assignRef('lang', $this->_lang);
		$this->_view->assignRef('task', $this->_task);
		
		
		$this->_view->display();
	}
	
	function moneyFormat() {
		
		JRequest::setVar('tmpl', 'component');
		
		$price = JRequest::getInt('price');
		
		if (empty($price))
		return false;
		$price = $this->_model->formatPrice($price);
		
		if ($this->_lang->getTag()=='ru-RU')
		setlocale(LC_MONETARY, 'ru_RU.UTF-8');
		else
		setlocale(LC_MONETARY, 'en_US');				
		$locale_settings = localeconv();
		
		$price .= '&nbsp;'.$locale_settings['currency_symbol'];
		
		echo $price;
	}
	
	function sendPayRequest() {
		
		//jimport('joomla.utilities.date');
		
		$cart_total = &JRequest::getInt('total');
		$cart_curr = &JRequest::getString('curr');
		$items = &JRequest::getString('items');
		
		$items = base64_decode($items);
		
		$items = explode(':', $items);
		$empty = array_pop($items);
		
		foreach ($items as $key=>$item) {
			$tmp = explode(',', $item);
			$this->_tids[$key]=array();
			$this->_tids[$key]['id']=$tmp[0];
			$this->_tids[$key]['price']=$tmp[1];
			$this->_tids[$key]['exc']=$tmp[2];
		}
		
		$order_data = array();
		$order_data['data'] = $this->_tids;
		$order_data['invoice_total'] = $cart_total;
		$order_data['order_id'] = md5(sha1('templateserver.ru order '.time(), 1));
		$order_data['merchant_id'] = 'i5653827859';
		$order_data['merc_sign'] = 'WjMrnaqcgXCVlidPxWVH2FMfTOU5kSX';
		$order_data['liqpay_url'] = 'https://liqpay.com/?do=clickNbuy';
		$order_data['sender_phone'] = '+'.'380503987965';
		
		$description = "Designs".' ';
		foreach ($this->_tids as $key=>$item) :
		$description .= $item['id'].' ';
		endforeach;
		$description .= JText::_('FROM').' '.JURI::base();
		
		$xml="<request>      
		      <version>1.2</version>";
		//$xml .= "<result_url>".JURI::base()."index.php?option=com_jtm&task=buy-template&act=client-result&order_id=$order_id</result_url>
		//      <server_url>".JURI::base()."index.php?option=com_jtm&task=buy-template&act=liqpay-result&order_id=$order_id</server_url>";
		$xml .= "<result_url>".JURI::base()."liqpay-client-result-test.html</result_url>
		      <server_url>".JURI::base()."liqpay-server-result-test.html</server_url>";
		$xml .= "<merchant_id>".$order_data['merchant_id']."</merchant_id>
		      <order_id>".$order_data['order_id']."</order_id>
		      <amount>".$this->_model->formatPrice($order_data['invoice_total'])."</amount>
		      <currency>".$cart_curr."</currency>
		      <description>".$description."</description>
		      <default_phone>".$order_data['sender_phone']."</default_phone>
		      <pay_way>card</pay_way>
		</request>";
		
		$order_data['xml_encoded']=base64_encode($xml);
		$order_data['signature'] = base64_encode(sha1($merc_sign.$xml.$merc_sign,1));
		
		$send_data=array();
		$send_data['signature']=$order_data['signature'];
		$send_data['xml_encoded']=$order_data['xml_encoded'];
		
		$_SERVER['REQUEST_METHOD']==='POST' or jexit('Wrong request method');  // REQUIRE POST OR DIE
		// Send request to liqpay server
		$url = $order_data['liqpay_url'];
		if ($ch = curl_init($url)){
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Expect:'));
			curl_setopt($ch, CURLOPT_FAILONERROR, 0);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // allow redirects
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,1); // return into a variable
			curl_setopt($ch, CURLOPT_TIMEOUT, 20); // times out after Ns
			curl_setopt($ch, CURLOPT_POST, 1); // set POST method
			curl_setopt($ch, CURLOPT_POSTFIELDS, $send_data); // add POST fields
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_HEADER, 1);
			
			$result = curl_exec($ch); // run the whole process
			curl_close($ch);
			
		} else {
			JError::raiseError(100, 'Cannot initialize CURL!');
		}
		
	}
}