<?php

class JtmHelper {
	
	var $_data = null;
	
	function getLang() {
		$language = JFactory::getLanguage();
		$l = $language->getTag();
		
		return $l;
	}
	
	function getLangShort() {
		$language = JFactory::getLanguage();
		$l = $language->getTag();
		$l = ereg_replace('-[A-Z]+$', '', $l);
		
		return $l;
	}
	
	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	function getStylesAssoc(){
		$database = &JFactory::getDBO();
		$query = "SELECT `styleid`,`title` FROM `#__jtm_styles`";
		
		$database->setQuery($query);
		$result =& $database->loadAssocList();
		
		
		return $result;
	}
	
	/**
	 * Get categories with optional adult filter
	 *
	 * @param boolean $adult_on
	 * @return array
	 */
	
	function getCategoriesAssoc($adult_on=0)
	{ 
		$db =& JFactory::getDBO();
		
		$query = "SELECT `catid`,`title` FROM #__jtm_categories ".
		"ORDER BY `title` ASC";
		
		$db->setQuery($query);
		$categories = $db->loadAssocList();
		
		foreach ($categories as $key=>$cat) {
			
		
			if ($adult_on==0) :
			if (eregi('adult', $cat['title']))
			unset($categories[$key]);
			endif;
		}
		
		$r = array();
		foreach ($categories as $value):
		$r[]=$value;
		endforeach;
		$result = $r;
		
		return $result;
		
	}
	
	function getTypesAssoc() {
		$database = &JFactory::getDBO();
		$query = "SELECT `description` FROM `#__jtm_ttypes` ORDER BY `description` ASC ";
		$database->setQuery($query);
		$result=&$database->loadAssocList();
		
		$types = array();
		foreach ($result as $record) {
			$al = JFilterOutput::stringURLSafe($record['description']);
			$types[$al]=$record['description'];
		}
		
		return $types;
	}
	
	/**
	 * This method processes a string and replaces all accented UTF-8 characters by unaccented
	 * ASCII-7 "equivalents", whitespaces are replaced by hyphens and the string is lowercased.
	 *
	 * @static
	 * @param	string	$input	String to process
	 * @return	string	Processed string
	 * @since	1.5
	 */
	function stringURLSafe($string)
	{
		//remove any '-' from the string they will be used as concatenator
		$str = str_replace('-', ' ', $string);

		$lang =& JFactory::getLanguage();
		$str = $lang->transliterate($str);

		// remove any duplicate whitespace, and ensure all characters are alphanumeric
		$str = preg_replace(array('/\s+/','/[^A-Za-z0-9\-]/'), array('-',''), $str);

		// lowercase and trim
		$str = trim(strtolower($str));
		return $str;
	}
	
	/**
	 * Generate alias for JText
	 *
	 * @param string $string
	 * @param string $suffix
	 * @return string
	 */
	function genJTextAlias($string, $sfx) {
		
		
		$string=str_replace('&', 'and', $string);
		$string=str_replace('/', ' or ', $string);
		$string .= ' '.$sfx;
		$s = JFilterOutput::stringURLSafe($string);
		$s = strtoupper($s);
		
		return $s;
	}
	
	function parseXMLData($xmldoc=null) {
		
		if ($xmldoc == null)
		return false;
		
		$template = array();
		
		foreach ($xmldoc as $child) {
			$children = $child->children();
			
			if (empty($children)) {
				$cn = strval($child->getName());
				$cd = trim(strval($child));
				
				if ($cn == 'keywords')
				$templates['keywords']= trim(explode(' ', $cd));
							
				$templates[$cn]=$cd;
							
				} else {
					$parent1 = $child->getName();
					foreach ($children as $child) {
						$children = $child->children();	
						if (empty($children)) {
							$cn = $child->getName();
							$cd = trim(strval($child));
							$templates[$parent1][$cn]=$cd;
							
						} else {
							
							$parent2 = $child->getName();
							foreach ($children as $child) {
								$children = $child->children();
								
								if (empty($children)) {
									$cn = $child->getName();
									$cd = trim(strval($child));
									$templates[$parent1][$parent2][$cn][]=$cd;
								} else {
									$parent3 = $child->getName();
									foreach ($children as $child) {
										$children = $child->children();
										if (empty($children)) {
											$cn = $child->getName();
											$cd = trim(strval($child));
											$templates[$parent1][$parent2][$parent3][$cn][]=$cd;
										} else {
											$parent4 = $child->getName();
											foreach ($children as $child) {
												$children = $child->children();
												if (empty($children)) {
													$cn = $child->getName();
													$cd = trim(strval($child));
													$templates[$parent1][$parent2][$parent3][$parent4][$cn][]=$cd;
												} else {
													$parent5 = $child->getName();
													foreach ($children as $child) {
														$children = $child->children();
														if (empty($children)) {
															$cn = $child->getName();
															$cd = trim(strval($child));
															$templates[$parent1][$parent2][$parent3][$parent4][$parent5][$cn][]=$cd;
														}
													}
												}
											}
										}
										
									}
								}
								
							}
										
						}
								
					}
							
							
				}
						
		}
		
		
		return $templates;
	}
	
	function getActiveMenu() {
		
		$menus =& JSite::getMenu();
		
		if (!$menus->getActive()===false) {
		
			$items = $menus->getItems('component', 'com_jtm');
			
			foreach ($items as $item)
			if (eregi('view=frontpage', $item->link))
			
			return $item;
			
		} 
		
		return $menus->getActive();
	}
	
	function auxJS() {
		$result = "
		window.addEvent('domready', function() {
	
			var cat_link_height = 26;
			
			var cats_wraps = $('jtm_wrap').getElements('td[class=cats]').getElements('div[class=wrap]')
			
			cats_wraps.each(function(item){
				
				var wrap_height = parseInt(item.getStyle('height'));
				item.setStyle('height',cat_link_height);
			});
			
			var cats_tds = $('jtm_wrap').getElements('td[class=cats]');
			
			// Add More button
			cats_tds.each(function(td){
				
				var moreBtn = new Element('div', {
					'id':'more_cats_btn',
					'class':'jtmTip',
					'title':'".JText::_('MORE CATEGORIES')."',
					'styles': {
						'position':'relative',
						'height':32,
						'width':16,
						'top':-26,
						'float':'right',
						'right':0,
						'background':'url(/components/com_jtm/images/cat_plus_btn.png)',
						'background-repeat':'no-repeat',
						'color':'#fff'
					}
					
				});
				td.adopt(moreBtn);
				
				moreBtn.addEvents({
					'click': function() {
						
						var cats_wraps = $('jtm_wrap').getElements('td[class=cats]').getElements('div[class=wrap]');
						var wrap = td.getElement('div[class=wrap]');
						var cat_links = wrap.getElements('a');
							
						var wrap_height = parseInt(wrap.getStyle('height'));
						var new_wrap_height = wrap_height+cat_link_height;
						
						var links_amt = cat_links.length;
						var max_height = cat_link_height*links_amt;
						var cats_less_btn_top = parseInt('-'+new_wrap_height);
						
						var fx = new Fx.Style(wrap, 'height', {duration:500, transition: Fx.Transitions.linear });
						
						if (new_wrap_height==max_height+cat_link_height) {
							moreBtn.remove();
						} else {
							var nwh2 = new_wrap_height-cat_link_height;
							fx.start(nwh2, new_wrap_height);
						}
					},
					
					'mouseover': function() {
						
						moreBtn.setStyle('cursor','pointer');
					}
				});
			});
			
			var tooltips = $$('.jtmTip');
	
			var cats_tips = new Tips(tooltips, {
				className: 'cat_tip',
				fixed: false,
				hideDelay: 100,
				showDelay: 50,
				maxTitleChars: 20
			});
			
			cats_tips.addEvent({
				'show': function(tip) {
					tip.fade('in');
				},
				'hide': function(tip) {
					tip.fade('out');
				}
			});
			
		});";
		
		return $result;
	}

}