/**
 * Javascript for JTM Component frontend
 *
 * @package    Joomla
 * @subpackage Components
 * components/com_jtm/js/cart.js
 * @license    GNU/GPL
 * @copyright (C) 2009 Antony Repin
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: cart.js,v 1.2 2010/04/09 09:15:55 cvs Exp $
*/
			

window.addEvent('domready', function() {
	
	updateTotal();
	
	// Upate total price and format on radio button click
	$('jtm_wrap').getElements('input[type=radio]').each(function(item){
		item.addEvent('click', function(){
			$('cart_total').innerHTML = 'Updating price'+'...';
			updateTotal();
		});
		/*
		item.addEvent('load', function(){
			updateTotal();
		});
		*/
	});
});

/**
 * Send payment data to script
 *
 */
function proceedToPayment() {
	
	var cart_total = getCartTotal();
	var curr = $('jtm_wrap').getElement('input[name=currency]').value;
	
	var templates = getCartTemplates();
	var items = '';
	if (templates) {
		var count = templates.length;
		for (var i=0;i<count;i++) {
			var tid = templates[i][0];
			var price = templates[i][1];
			var exc = templates[i][2];
			var template_string = tid+','+price+','+exc;
			items = items+template_string+':';
		}
	} else {
		return false;
	}
	
	items = encodeBase64(items);
	
	var request = new Request({
		method: 'post',
		url: 'index.php',
		data: {
			'option':'com_jtm',
			'c':'ajax',
			'rs':'1',
			'task':'sendpayrequest',
			'items':items,
			'total':cart_total,
			'curr':curr
		},
		onRequest: function() {
			var preloader = loadPreloader(); 
			$('invoice').innerHTML='';
			$('invoice').adopt(preloader);
		},
		
		//update: $('invoice'),
		
		onComplete: function(response) {
			$('invoice').innerHTML=response;
			if ($('preloader'))
			$('preloader').dispose();
		},
		onFailure: function() {
			$('invoice').innerHTML='Запрос не выполнен. Кликните <a href="javascript:proceedToPayment();">здесь</a> чтобы перезагрузить страницу.';
		}
		
	}).send();
}


/**
 *
 * Hide checkout buttons on reuqest process
 *
 */
function hideCheckoutButtons() {
	var btns = $('jtm_wrap').getElements('a[id=btn_checkout]');
	btns.each(function(item){
		item.setStyle('visibility', 'hidden');
	});
}

/**
 * Load invoice into dialog window
 *
 */
function loadInvoice() {
	
	$('dialog').adopt(new Element('div', {
		id: 'invoice',
		"styles": {
			"width": '100%',
			'height': '100%',
			'position':'relative',
			'top':20,
			'overflow':'hidden'
		}
	}));
	
	var cart_total = getCartTotal();
	var curr = $('jtm_wrap').getElement('input[name=currency]').value;
	
	var templates = getCartTemplates();
	var items = '';
	if (templates) {
		var count = templates.length;
		for (var i=0;i<count;i++) {
			var tid = templates[i][0];
			var price = templates[i][1];
			var exc = templates[i][2];
			var template_string = tid+','+price+','+exc;
			items = items+template_string+':';
		}
	} else {
		return false;
	}
	
	items = encodeBase64(items);
	
	var request = new Request({
		method: 'get',
		url: 'index.php',
		data: {
			'option' : 'com_jtm',
			'c':'ajax',
			'rs':'1',
			'task':'invoice',
			'items':items,
			'price':cart_total,
			'curr':curr
		},
		
		onRequest: function() {
			//var preloader = loadPreloader(); 
			//$('dialog').adopt(preloader); 
		},
		onComplete: function(response) {
			$('preloader').dispose();
			$('invoice').innerHTML=response;
	
		},
		onFailure: function() {
			$('invoice').innerHTML="Request failed. Please close this modal window and try again.<br>";
		}
	}).send();
}

/**
 *
 * Get cart templates data
 *
 */
function getCartTemplates() {
	
	var templates = $('jtm_wrap').getElements('div[id=cart_prices]');
	
	
	var result = new Array;
	var c=0;
	templates.each(function(item) {
		var radio_group = item.getElements('input[name^=pr_]');
		radio_group.each(function(item){
				var tid = item.name.substr(3,5);
				var jtmcookie = Cookie.read('jtmcart:'+tid);
				
				var template = jtmcookie.split(":");
				var tid_get = template[0].split('=');
				var exclusive = template[1].split('=');
				
				if (item.checked==true) {
					var price = item.value;
					if (item.id=='exc_1') {
						exc=1;
					} else {
						exc=0;
					}
					result[c] = [tid, price, exc];
					c++;	
				}
		});
	});
	return result;
}

/**
 *
 * Generate cart total
 *
 */
function getCartTotal() {
	var templates = $('jtm_wrap').getElements('div[id=cart_prices]');
	var cart_total = 0;
	
	templates.each(function(item) {
		var radio_group = item.getElements('input[name^=pr_]');
		radio_group.each(function(item){
			var tid = item.name.substr(3,5);
			if (item.checked==true) {
				cart_total += parseInt(item.value);
			}
		});
	});
	
	return cart_total;
}


/**
 * Upate total price and format 
 *
 */
function updateTotal() {
	var templates = $('jtm_wrap').getElements('div[id=cart_prices]');
	var cart_total = 0;
	
	templates.each(function(item) {
		var radio_group = item.getElements('input[name^=pr_]');
		radio_group.each(function(item){
			var tid = item.name.substr(3,5);
			if (item.checked==true) {
				Cookie.dispose('jtmcart:'+tid);
				cart_total += parseInt(item.value);
				if (item.id=='exc_0') {
					var cookie = Cookie.write('jtmcart:'+tid, 'tid='+tid+':exc=0', {duration: 365});
				}
				
				if (item.id=='exc_1') {
					var cookie = Cookie.write('jtmcart:'+tid, 'tid='+tid+':exc=1', {duration: 365});
				}
			}
		});
	});
	
	var priceFormatRequest = new Request({
		method: 'get',
		url: 'index.php',
		data: {
			'option': 'com_jtm',
			'c':'ajax',
			'rs':1,
			'task':'moneyformat',
			'price': cart_total
		},
		onRequest: function() {
			hideCheckoutButtons();
		},
		onComplete: function(response){
			var btns = $('jtm_wrap').getElements('a[id=btn_checkout]');
			btns.each(function(item){
				item.setStyle('visibility', 'visible');
				// Buggy
				//item.addEvent('click', function(){
					//toggleModal('#fff'); // Load modal background
					//loadInvoice(); // Load invoice into modal window	
				//});
				//item.setStyle('visibility', 'visible');
				
			});
			$('cart_total').innerHTML = response;
		},
		onFailure: function() {
			$('cart_total').innerHTML="Request failed. Please close this modal window and try again.<br>";
		}
	}).send();
	
	
		
}

/**
 * Load modal background and transparency layers
 *
 */
/*
function toggleModal(backgroundColour, options) {
	
	if ($("modal")) {
		$("modal").dispose();
		return false;
	}
	
	var options = $merge({
		zIndex: 10000,
		opacity: .88,
		events: $empty()
	}, options);
	
	if (!$type(backgroundColour) && !$("modal"))
	return false;
	
	var modal_bg = new Element("div", {
		id: "modal",
		styles: {
			position: "absolute",
			top: 0,
			left: 0,
			width: window.getScrollWidth(),
			height: window.getScrollHeight(),
			"z-index": options.zIndex
		},
		events: options.events
	}) ;
	modal_bg.inject(document.body);
	
	$('modal').adopt(new Element('div', {
		'id': 'transparency',
		styles: {
			position: "absolute",
			top: 0,
			left: 0,
			width: window.getScrollWidth(),
			height: window.getScrollHeight(),
			background: backgroundColour,
			"z-index": options.zIndex+1
		},
		opacity: options.opacity,
		events: options.events
	}));
	
	// Create dialog window
	var dialog_width = "80%";
	var pos_top = 50;
	var dialog_height = 400;
	var pos_left = "10%";
	var dialog = new Element("div", {
		id: "dialog",
		"styles" : {
			"position": "absolute",
			"width": dialog_width,
			"height": dialog_height,
			'top': pos_top,
			"left": pos_left,
			'border': 'solid 5px #000',
			'background': '#ededed',
			'z-index':11000,
			'overflow':'hidden'
		}
	});
	
	$('modal').adopt(dialog); // Load dialog window
	
	var preloader = loadPreloader();
	$('dialog').adopt(preloader); // Load dialog window
	
	var close_btn = new Element('div',{
		id:'close_btn',
		styles: {
			"position": "relative",
			'float':'right',
			"width": 16,
			"height": 16,
			'right': -16,
			"top": -16,
			'background': '#ff0000',
			'border':'4px solid #000',
			'z-index':12000
		},
		'events':{
			'mouseover':function() {
				$('close_btn').setStyle('cursor', 'pointer');
			},
			'click':function() {
				modalClose();
			}
		}
	});
	
	$('dialog').adopt(close_btn); // Load close button
}  

function loadPreloader() {
	var preloader = new Element('div', {
		id:'preloader',
		styles: {
			"position": "relative",
			"width": 50,
			"height": 50,
			'top': '49%',
			"left": '49%',
			'background': '#ffcc00',
			'border':'2px solid #000',
			'z-index':11001
		},
		text: 'Loading...'
	});
	return preloader;
}

function modalClose() {
	$('close_btn').dispose();
	if ($('preloader')){
		preloader = $('preloader').dispose;
	}
	$('dialog').dispose();
	$('transparency').dispose();
	$('modal').dispose();
}
*/
	
/*
 *
 * Encoding functions
 *
 */
var END_OF_INPUT = -1;

var base64Chars = new Array(
    'A','B','C','D','E','F','G','H',
    'I','J','K','L','M','N','O','P',
    'Q','R','S','T','U','V','W','X',
    'Y','Z','a','b','c','d','e','f',
    'g','h','i','j','k','l','m','n',
    'o','p','q','r','s','t','u','v',
    'w','x','y','z','0','1','2','3',
    '4','5','6','7','8','9','+','/'
);

var reverseBase64Chars = new Array();
for (var i=0; i < base64Chars.length; i++){
    reverseBase64Chars[base64Chars[i]] = i;
}

var base64Str;
var base64Count;
function setBase64Str(str){
    base64Str = str;
    base64Count = 0;
}
function readBase64(){    
    if (!base64Str) return END_OF_INPUT;
    if (base64Count >= base64Str.length) return END_OF_INPUT;
    var c = base64Str.charCodeAt(base64Count) & 0xff;
    base64Count++;
    return c;
}
function encodeBase64(str){
    setBase64Str(str);
    var result = '';
    var inBuffer = new Array(3);
    var lineCount = 0;
    var done = false;
    while (!done && (inBuffer[0] = readBase64()) != END_OF_INPUT){
        inBuffer[1] = readBase64();
        inBuffer[2] = readBase64();
        result += (base64Chars[ inBuffer[0] >> 2 ]);
        if (inBuffer[1] != END_OF_INPUT){
            result += (base64Chars [(( inBuffer[0] << 4 ) & 0x30) | (inBuffer[1] >> 4) ]);
            if (inBuffer[2] != END_OF_INPUT){
                result += (base64Chars [((inBuffer[1] << 2) & 0x3c) | (inBuffer[2] >> 6) ]);
                result += (base64Chars [inBuffer[2] & 0x3F]);
            } else {
                result += (base64Chars [((inBuffer[1] << 2) & 0x3c)]);
                result += ('=');
                done = true;
            }
        } else {
            result += (base64Chars [(( inBuffer[0] << 4 ) & 0x30)]);
            result += ('=');
            result += ('=');
            done = true;
        }
        lineCount += 4;
        if (lineCount >= 76){
            result += ('\n');
            lineCount = 0;
        }
    }
    return result;
}
function readReverseBase64(){   
    if (!base64Str) return END_OF_INPUT;
    while (true){      
        if (base64Count >= base64Str.length) return END_OF_INPUT;
        var nextCharacter = base64Str.charAt(base64Count);
        base64Count++;
        if (reverseBase64Chars[nextCharacter]){
            return reverseBase64Chars[nextCharacter];
        }
        if (nextCharacter == 'A') return 0;
    }
    return END_OF_INPUT;
}

function ntos(n){
    n=n.toString(16);
    if (n.length == 1) n="0"+n;
    n="%"+n;
    return unescape(n);
}

function decodeBase64(str){
    setBase64Str(str);
    var result = "";
    var inBuffer = new Array(4);
    var done = false;
    while (!done && (inBuffer[0] = readReverseBase64()) != END_OF_INPUT
        && (inBuffer[1] = readReverseBase64()) != END_OF_INPUT){
        inBuffer[2] = readReverseBase64();
        inBuffer[3] = readReverseBase64();
        result += ntos((((inBuffer[0] << 2) & 0xff)| inBuffer[1] >> 4));
        if (inBuffer[2] != END_OF_INPUT){
            result +=  ntos((((inBuffer[1] << 4) & 0xff)| inBuffer[2] >> 2));
            if (inBuffer[3] != END_OF_INPUT){
                result +=  ntos((((inBuffer[2] << 6)  & 0xff) | inBuffer[3]));
            } else {
                done = true;
            }
        } else {
            done = true;
        }
    }
    return result;
}
var digitArray = new Array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');
function toHex(n){
    var result = ''
    var start = true;
    for (var i=32; i>0;){
        i-=4;
        var digit = (n>>i) & 0xf;
        if (!start || digit != 0){
            start = false;
            result += digitArray[digit];
        }
    }
    return (result==''?'0':result);
}

function pad(str, len, pad){
    var result = str;
    for (var i=str.length; i<len; i++){
        result = pad + result;
    }
    return result;
}

function encodeHex(str){
    var result = "";
    for (var i=0; i<str.length; i++){
        result += pad(toHex(str.charCodeAt(i)&0xff),2,'0');
    }
    return result;
}

var hexv = {
  "00":0,"01":1,"02":2,"03":3,"04":4,"05":5,"06":6,"07":7,"08":8,"09":9,"0A":10,"0B":11,"0C":12,"0D":13,"0E":14,"0F":15,
  "10":16,"11":17,"12":18,"13":19,"14":20,"15":21,"16":22,"17":23,"18":24,"19":25,"1A":26,"1B":27,"1C":28,"1D":29,"1E":30,"1F":31,
  "20":32,"21":33,"22":34,"23":35,"24":36,"25":37,"26":38,"27":39,"28":40,"29":41,"2A":42,"2B":43,"2C":44,"2D":45,"2E":46,"2F":47,
  "30":48,"31":49,"32":50,"33":51,"34":52,"35":53,"36":54,"37":55,"38":56,"39":57,"3A":58,"3B":59,"3C":60,"3D":61,"3E":62,"3F":63,
  "40":64,"41":65,"42":66,"43":67,"44":68,"45":69,"46":70,"47":71,"48":72,"49":73,"4A":74,"4B":75,"4C":76,"4D":77,"4E":78,"4F":79,
  "50":80,"51":81,"52":82,"53":83,"54":84,"55":85,"56":86,"57":87,"58":88,"59":89,"5A":90,"5B":91,"5C":92,"5D":93,"5E":94,"5F":95,
  "60":96,"61":97,"62":98,"63":99,"64":100,"65":101,"66":102,"67":103,"68":104,"69":105,"6A":106,"6B":107,"6C":108,"6D":109,"6E":110,"6F":111,
  "70":112,"71":113,"72":114,"73":115,"74":116,"75":117,"76":118,"77":119,"78":120,"79":121,"7A":122,"7B":123,"7C":124,"7D":125,"7E":126,"7F":127,
  "80":128,"81":129,"82":130,"83":131,"84":132,"85":133,"86":134,"87":135,"88":136,"89":137,"8A":138,"8B":139,"8C":140,"8D":141,"8E":142,"8F":143,
  "90":144,"91":145,"92":146,"93":147,"94":148,"95":149,"96":150,"97":151,"98":152,"99":153,"9A":154,"9B":155,"9C":156,"9D":157,"9E":158,"9F":159,
  "A0":160,"A1":161,"A2":162,"A3":163,"A4":164,"A5":165,"A6":166,"A7":167,"A8":168,"A9":169,"AA":170,"AB":171,"AC":172,"AD":173,"AE":174,"AF":175,
  "B0":176,"B1":177,"B2":178,"B3":179,"B4":180,"B5":181,"B6":182,"B7":183,"B8":184,"B9":185,"BA":186,"BB":187,"BC":188,"BD":189,"BE":190,"BF":191,
  "C0":192,"C1":193,"C2":194,"C3":195,"C4":196,"C5":197,"C6":198,"C7":199,"C8":200,"C9":201,"CA":202,"CB":203,"CC":204,"CD":205,"CE":206,"CF":207,
  "D0":208,"D1":209,"D2":210,"D3":211,"D4":212,"D5":213,"D6":214,"D7":215,"D8":216,"D9":217,"DA":218,"DB":219,"DC":220,"DD":221,"DE":222,"DF":223,
  "E0":224,"E1":225,"E2":226,"E3":227,"E4":228,"E5":229,"E6":230,"E7":231,"E8":232,"E9":233,"EA":234,"EB":235,"EC":236,"ED":237,"EE":238,"EF":239,
  "F0":240,"F1":241,"F2":242,"F3":243,"F4":244,"F5":245,"F6":246,"F7":247,"F8":248,"F9":249,"FA":250,"FB":251,"FC":252,"FD":253,"FE":254,"FF":255
};

function decodeHex(str){
    str = str.toUpperCase().replace(new RegExp("s/[^0-9A-Z]//g"));
    var result = "";
    var nextchar = "";
    for (var i=0; i<str.length; i++){
        nextchar += str.charAt(i);
        if (nextchar.length == 2){
            result += ntos(hexv[nextchar]);
            nextchar = "";
        }
    }
    return result;
    
}


function urlencode (str) {
    // http://kevin.vanzonneveld.net
    // +   original by: Philip Peterson
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: AJ
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: travc
    // +      input by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Lars Fischer
    // +      input by: Ratheous
    // +      reimplemented by: Brett Zamir (http://brett-zamir.me)
    // %          note 1: This reflects PHP 5.3/6.0+ behavior
    // *     example 1: urlencode('Kevin van Zonneveld!');
    // *     returns 1: 'Kevin+van+Zonneveld%21'
    // *     example 2: urlencode('http://kevin.vanzonneveld.net/');
    // *     returns 2: 'http%3A%2F%2Fkevin.vanzonneveld.net%2F'
    // *     example 3: urlencode('http://www.google.nl/search?q=php.js&ie=utf-8&oe=utf-8&aq=t&rls=com.ubuntu:en-US:unofficial&client=firefox-a');
    // *     returns 3: 'http%3A%2F%2Fwww.google.nl%2Fsearch%3Fq%3Dphp.js%26ie%3Dutf-8%26oe%3Dutf-8%26aq%3Dt%26rls%3Dcom.ubuntu%3Aen-US%3Aunofficial%26client%3Dfirefox-a'
 
    var hexStr = function (dec) {
        return '%' + dec.toString(16).toUpperCase();
    };
 
    var ret = '',
            unreserved = "/[\w.-]/"; // A-Za-z0-9_.- // Tilde is not here for historical reasons; to preserve it, use rawurlencode instead
    str = (str+'').toString();
 
    for (var i = 0, dl = str.length; i < dl; i++) {
        var ch = str.charAt(i);
        if (unreserved.test(ch)) {
            ret += ch;
        }
        else {
            var code = str.charCodeAt(i);
            // Reserved assumed to be in UTF-8, as in PHP
            if (code === 32) {
                ret += '+'; // %20 in rawurlencode
            }
            else if (code < 128) { // 1 byte
                ret += hexStr(code);
            }
            else if (code >= 128 && code < 2048) { // 2 bytes
                ret += hexStr((code >> 6) | 0xC0);
                ret += hexStr((code & 0x3F) | 0x80);
            }
            else if (code >= 2048 && code < 65536) { // 3 bytes
                ret += hexStr((code >> 12) | 0xE0);
                ret += hexStr(((code >> 6) & 0x3F) | 0x80);
                ret += hexStr((code & 0x3F) | 0x80);
            }
            else if (code >= 65536) { // 4 bytes
                ret += hexStr((code >> 18) | 0xF0);
                ret += hexStr(((code >> 12) & 0x3F) | 0x80);
                ret += hexStr(((code >> 6) & 0x3F) | 0x80);
                ret += hexStr((code & 0x3F) | 0x80);
            }
        }
    }
    return ret;
}