<?php
/**
 * @package    Joomla
 * @subpackage Components
 * components/com_jtm/router.php
 * @license    GNU/GPL
 * @copyright (C) 2009 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: router.php,v 1.7 2010/04/17 02:39:53 cvs Exp $
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.router' );


function JtmBuildRoute( &$query ) {
	$segments = array();
	
	if (isset($query['view'])) {
		
		if ($query['view']=='categories') :
			$segments[]='category';
		elseif ($query['view']=='styles') :
			$segments[]='style';
		elseif ($query['view']=='single') :
			$segments[]='template-'.$query['tid'].'-details';
			unset ($query['tid']);
		else :
			$segments[]=$query['view'];
			
		endif;
		
		unset ($query['view']);
	}
	
	if (isset($query['tid']))
	$segments[]=$query['tid'];
	unset($query['tid']);
	
	if (isset($query['category']))
	$segments[]=$query['category'];
	unset($query['category']);
	
	if (isset($query['style']))
	$segments[]=$query['style'];
	unset($query['style']);
	
	
	return $segments;

}

function JtmParseRoute($segments) {
	
	$vars = array();
	if (isset($segments[0]) && !empty($segments[0])) {
		switch ($segments[0]){
			case 'category':
					$vars['view'] = 'categories';
					$vars['category'] = $segments[1];
				break;
				
			case 'style':
				$vars['view'] = 'styles';
				$vars['style'] = $segments[1];
				
			case 'single':
				$vars['view'] = 'single';
				$vars['tid'] = $segments[1];
				break;
				
				default:
					JError::raiseError(500, 'Error parsing route!');
			
		}
	}
    
	return $vars;
}
