<?php
/**
 * @package    Joomla
 * @subpackage Components
 * components/com_jtm/views/search/tmpl/default.php
 * @license    GNU/GPL
 * @copyright (C) 2009 egeshi.com
 * @author Antony Repin <egeshisolutions@gmail.com>
 * @version $Id: default.php,v 1.13 2010/04/16 21:23:33 cvs Exp $
*/

// No direct access
defined('_JEXEC') or die('Restricted access'); 

// Locale settings
$lang_short = eregi_replace('-.+', '', $this->lang->getTag());

echo '<div class="componentheading'.$this->params->get('pageclass_sfx').'">';
echo '<h1>'.JText::_('TEMPLATE SEARCH PAGE HEADER').'</h1>';
echo '</div>';

echo '<div class="jtm_search_terms"><p>'.JText::_('SEARCH CRITERIA').':'.'</p>';

foreach ($this->terms as $value) {
	$v = ereg_replace('Keywords', JText::_('SEARCH KEYWORDS'), $value);
	echo "<p>$v</p>";
}

?>
</div>
<div id="jtm_wrap">
	<div class="templates_wrap" style="width: <?php echo $this->width,';' ?>">
		<div class="form">
			<?php 
			$form = $this->_model->getSearchForm(); 
			echo $form;
			?>
		</div>
		<div class="clear"></div>
		<div class="pagination">
			<div class="wrap">
				<div class="results-counter"><?php echo $this->_pagination->getResultsCounter(); ?></div>
				<div class="pages"><?php echo $this->_pagination->getPagesLinks(); ?></div>
				<div class="clear"></div>
			</div>
			<div class="gotopage">
				<?php echo $this->_pagination->getPagescounter(); ?><br />
				<?php 
				echo JText::_('GO TO PAGE').' #' ;
				$ct = JFilterOutput::stringURLSafe($this->category);
				?>
				<form action="index.php" method="post">
				<input type="hidden" name="Itemid" value="<?php echo $this->menu->id ?>"></input>
				<input type="hidden" name="option" value="<?php echo JRequest::getCmd('option') ?>"></input>
				<input type="hidden" name="view" value="<?php echo JRequest::getCmd('view') ?>"></input>
				<input type="hidden" name="category" value="<?php echo $ct ?>"></input>
				<input type="text" size="3" name="page" id="pagenum"></input>
				</form>
			</div>
				<div class="clear"></div>
		</div>
		<?

			$tlist = $this->tlist;
			$count = count($tlist);

			$tcount = 0;
			$row = 0;
			$col = 0;
			
			for ($i=1, $n=$count; $i<=$n;$i++) {
				
				$m = $i-1;
				
				$thumb = $tlist[$m]['screenshots_list']['screenshot']['uri']['thumbnail'];
				$tid = $tlist[$m]['id'];
				
				if ($tcount == 0) {
					echo '<table width="100%" cellpadding="0" cellspacing="0" border="0"></tbody>';
					$tcount =1;
				}
				
				if ($i%4==1) {
					echo '<tr>';
					$row++;
					$col=1;
				} else {
					$col++;
				}
				?>
				<td valign="top">
				
					<table class="templates" width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr>
							<td class="thumb" align="center" valign="top">
							<?php
							if (!empty($thumb)) : 
							?>
							<a id="<?php echo $tid ?>" href="<?php echo JRoute::_('index.php?view=single&tid='.$tid) ?>" target="_blank"><img src="<?php echo $thumb ?>" alt="<?php echo $tlist[$m]['template_type']['type_name'][0].' # '.$tid ?>" /></a>
							<?php
							else :
							echo '<img src="'.DS.'components'.DS.'com_jtm'.DS.'images'.DS.'upgrading.png" />';
							endif;
							?>
							</td>
						</tr>
						<?php
						if (!empty($tid)) { 
						?>
						<tr>
							<td class="picture-menu" align="center" valign="bottom">
							<div class="wrap">
								<a class="add" href="http://www.templatehelp.com/preset/cart.php?act=add&templ=<?php echo $tid ?>&pr_code=<?php echo $this->pr_code ?>" target="_blank" title="<?php echo ucwords(JText::_('ADD TO CART')) ?>" rel="nofollow"><?php echo JText::_('ADD TO CART') ?></a>
								<a class="details" href="<?php echo JRoute::_('index.php?option=com_jtm&view=single&tid='.$tid.'&Itemid='.$this->menu->id) ?>" target="_blank" title="<?php echo ucwords(JText::_('TEMPLATE PREVIEW')) ?>"><?php echo ucfirst(JText::_('TEMPLATE DETAILS')); ?></a>
							</div>
				    		</td>
						</tr>
						<tr>
							<td class="cats" align="center" valign="top">
							<div class="wrap">
								<?php
								$categories = $tlist[$m]['categories']['category']['category_name'];
								foreach ($categories as $cat) {
									$al = JText::_(JtmHelper::genJTextAlias($cat, "category"));
									$ct = JFilterOutput::stringURLSafe($cat);
									echo '<a class="template-group" href="'.JRoute::_('index.php?option=com_jtm&view=categories&category='.$ct.'&Itemid='.$this->menu->id).'">'.ucwords(strtolower(JText::_($al))).'</a>';
								}
								?>
							</div>
							<td>
						</tr>
						<tr>
							<td class="price" align="left" valign="bottom">
							<?php
							$price = $this->_model->getPrice($tlist[$m]['price']);
							$exc_price = $this->_model->getPrice($tlist[$m]['exc_price']);
						
							$price_formatted = $this->_model->formatPrice($price);
							$exc_price_formatted = $this->_model->formatPrice($exc_price);
							?>
							<div class="wrap"><div class="wrap">
								<div>
									<?php echo ucfirst(JText::_('DESIGN ID TEXT').' #'.$tlist[$m]['id']) ?>
								</div>
								<div>
									<?php echo ucfirst(JText::_('TEMPLATE DOWNLOADED').': '.$tlist[$m]['downloads'])  ?>
								</div>
								<div class="price"><?php echo ucfirst(JText::_('PRICE ONLY')).': '; ?>
									<span>
									<?php 
									if ($this->lang->getTag()=='ru-RU') :
									echo $price_formatted.' '.ucfirst(strtolower($locale_settings['currency_symbol']));
									else :
									echo ucfirst(strtolower($locale_settings['currency_symbol'])).' '.$price_formatted;
									endif;
									?></span>
								</div>
								<?php /*
								<div class="uniq-price"><?php echo JText::_(UNIQUE_PRICE).': '; ?>
									<span><?php echo $this->c_name.' '.$prices['exc_price']  ?></span>
								</div>
								*/ ?>
							</div>
							</td>
						</tr>
						<?php
						} else {
							?>
						<tr>
							<td class="price"><div class="wrap">&nbsp;</div></td>
						</tr>
						<?php
						}
						?>
						</table>
						</td>
				
				<?php
				if ($i%4==0) {
					echo '</tr>';
					$row = 2;
				} 
				
				
				if($i==$count) {
					echo '</tbody></table>';
					$col=0;
					$row = 1;
				}
				
				
				
			}
			$max = count($tlist);
			$k=0;

			
			?>
			<script type="text/javascript" src="<?php echo JURI::base().'components'.DS.'com_jtm'.DS.'js'.DS.'magnifimage.js' ?>"></script>
			<script type="text/javascript">
			MagnifImage.preLoad(false);
			MagnifImage.setup (
			<?php
			
			foreach ($tlist as $t) {
				$hover = $t['screenshots_list']['screenshot']['uri']['hover'];

				$tid = $t['id'];
				if (!empty($hover) && !empty($tid)) {
					$k++;
					if ($k<$max) :
					?>
					"<?php echo $tid ?>", "<?php echo $hover ?>", "<?php echo ucfirst(JText::_('TEMPLATE')).' '.$tid.' '.ucfirst(JText::_('PREVIEW'))?>",
					<?
					else :
					?>
					"<?php echo $tid ?>", "<?php echo $hover ?>", "<?php echo ucfirst(JText::_('TEMPLATE')).' '.$tid.' '.ucfirst(JText::_('PREVIEW'))?>"
					<?
					endif;
				} else {
					$max-=1;

				}
			}
			?>
			);
			</script>
		<div class="pagination">
			<div class="wrap">
				<div class="results-counter"><?php echo $this->_pagination->getResultsCounter(); ?></div>
				<div class="pages"><?php echo $this->_pagination->getPagesLinks(); ?></div>
				<div class="clear"></div>
			</div>
			<div class="gotopage">
				<?php echo $this->_pagination->getPagescounter(); ?><br />
				<?php 
				echo JText::_('GO TO PAGE').' #' ;
				$ct = JFilterOutput::stringURLSafe($this->category);
				?>
				<form action="index.php" method="GET">
				<input type="hidden" name="Itemid" value="<?php echo $this->menu->id ?>"></input>
				<input type="hidden" name="option" value="com_jtm"></input>
				<input type="hidden" name="view" value="categories"></input>
				<input type="hidden" name="category" value="<?php echo $ct ?>"></input>
				<input type="hidden" name="lang" value="<?php echo $lang_short ?>"></input>
				<input type="text" size="3" name="page" id="pagenum"></input>
				</form>
			</div>
			<div class="clear"></div>
		</div>
		<div class="clear"></div>
	</div>
	<?php
	if ($this->params->get('display_sidebar', 0)==1)
	echo '<div class="sidebar">'.$this->sidebar.'</div>';
	
	?>
	<div class="clear"></div>
	<div style="width:100%;">
		<?php echo $this->donation; ?>
	</div>
	<div class="clear"></div>
</div>