<?php
/**
 * @version		$Id: uninstall.php,v 1.3 2010/04/09 19:40:51 cvs Exp $
 * @package		jXZine
 * @copyright	2005-2008 New Life in IT Pty Ltd.  All rights reserved.
 * @license		GNU General Public License
 * 
 * This is the special installer addon created by Andrew Eddie and the team of jXtended.
 * We thank for this cool idea of extending the installation process easily
 */
defined('_JEXEC') or die('Restricted access');


jimport('joomla.application.helper');

//$nPaths = $this->_paths;
$status = new JObject();
$status->modules = array();
$status->plugins = array();

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * MODULE REMOVAL SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module)
	{
		$mname		= $module->attributes('module');
		$mclient	= JApplicationHelper::getClientInfo($module->attributes('client'), true);
		$mposition	= $module->attributes('position');

		// Set the installation path
		if (!empty ($mname)) {
			$this->parent->setPath('extension_root', $mclient->path.DS.'modules'.DS.$mname);
		} else {
			$this->parent->abort(JText::_('MODULE').' '.JText::_('INSTALL').': '.JText::_('NO MODULE FILE SPECIFIED'));
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO();

		// Lets delete all the module copies for the type we are uninstalling
		$query = 'SELECT `id`' .
				' FROM `#__modules`' .
				' WHERE module = '.$db->Quote($mname) .
				' AND client_id = '.(int)$mclient->id;
		$db->setQuery($query);
		$modules = $db->loadResultArray();

		// Do we have any module copies?
		if (count($modules)) {
			JArrayHelper::toInteger($modules);
			$modID = implode(',', $modules);
			$query = 'DELETE' .
					' FROM #__modules_menu' .
					' WHERE moduleid IN ('.$modID.')';
			$db->setQuery($query);
			if (!$db->query()) {
				JError::raiseWarning(100, JText::_('MODULE').' '.JText::_('UNINSTALL').': '.$db->stderr(true));
				$retval = false;
			}
		}

		// Delete the modules in the #__modules table
		$query = 'DELETE FROM #__modules WHERE module = '.$db->Quote($mname);
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseWarning(100, JText::_('PLUGIN').' '.JText::_('UNINSTALL').': '.$db->stderr(true));
			$retval = false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Remove all necessary files
		$element = &$module->getElementByPath('files');
		if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
			$this->parent->removeFiles($element, -1);
		}

		// Remove all necessary files
		$element = &$module->getElementByPath('media');
		if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
			$this->parent->removeFiles($element, -1);
		}

		$element = &$module->getElementByPath('languages');
		if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
			$this->parent->removeFiles($element, $mclient->id);
		}

		// Remove the installation folder
		if (!JFolder::delete($this->parent->getPath('extension_root'))) {
		}

		$status->modules[] = array('name'=>$mname,'client'=>$mclient->name);
	}
}

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * PLUGIN REMOVAL SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin)
	{
		$pname		= $plugin->attributes('plugin');
		$pgroup		= $plugin->attributes('group');

		// Set the installation path
		if (!empty($pname) && !empty($pgroup)) {
			$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.$pgroup);
		} else {
			$this->parent->abort(JText::_('PLUGIN').' '.JText::_('UNINSTALL').': '.JText::_('NO PLUGIN FILE SPECIFIED'));
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO();

		// Delete the plugins in the #__plugins table
		$query = 'DELETE FROM #__plugins WHERE element = '.$db->Quote($pname).' AND folder = '.$db->Quote($pgroup);
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseWarning(100, JText::_('PLUGIN').' '.JText::_('UNINSTALL').': '.$db->stderr(true));
			$retval = false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// Remove all necessary files
		$element = &$plugin->getElementByPath('files');
		if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
			$this->parent->removeFiles($element, -1);
		}

		$element = &$plugin->getElementByPath('languages');
		if (is_a($element, 'JSimpleXMLElement') && count($element->children())) {
			$this->parent->removeFiles($element, 1);
		}

		// If the folder is empty, let's delete it
		$files = JFolder::files($this->parent->getPath('extension_root'));
		if (!count($files)) {
			JFolder::delete($this->parent->getPath('extension_root'));
		}

		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup);
	}
}


/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/
 $rows = 0;
?>

<h2>JTM Reseller <?php echo JText::_("Component").' '.JText::_('Uninstallation'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" style="text-align: left; font-weight: bold;"><?php echo JText::_('Extension'); ?></th>
			<th></th>
			<th width="30%" style="text-align: center; font-weight: bold;"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" style="text-align: left;">JTM Reseller<?php echo JText::_("Component"); ?></td>
			<td></td>
			<td style="color: red; text-align: center;"><?php echo JText::_('Removed'); ?></td>
		</tr>
<?php 
if (count($status->modules)) { ?>
		<tr>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_('Module'); ?></th>
			<th style="font-weight: bold; text-align: left"><?php echo JText::_('Client'); ?></th>
			<th style="text-align: center; font-weight: bold;"><?php echo JText::_('STATUS'); ?></th>
		</tr>
	<?php 
	foreach ($status->modules as $module) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key" style="text-align: left;"><?php echo ucfirst($module['client']); ?></td>
			<td style="color: red; text-align: center;"><?php echo JText::_('REMOVED'); ?></td>
		</tr>
	<?php 
	}
}
if (count($status->plugins)) { ?>
		<tr>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_('Plugin'); ?></th>
			<th style="font-weight: bold; text-align: left;"><?php echo JText::_('Group') ?></th>
			<th style="text-align: center; font-weight: bold;"><?php echo JText::_('STATUS'); ?></th>
		</tr>
	<?php 
	foreach ($status->plugins as $plugin) { ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key" style="text-align: left;"><?php echo ucfirst($plugin['group']); ?></td>
			<td style="color: red; text-align: center;"><?php echo JText::_('Removed'); ?></td>
		</tr>
	<?php 
	}
} ?>
	</tbody>
</table>
<h5 style="color: red;">Thank you for using JTM Reseller component!</h5>
<h3 style="color: blue;">Templatemonster Reseller Component for Joomla</h3>